classdef CubeSatADSSDesign < matlab.apps.AppBase

    % Properties that correspond to app components
    properties (Access = public)
        CubeSatADSSDesignandSimulationUIFigure  matlab.ui.Figure
        TabGroup                        matlab.ui.container.TabGroup
        CubeSatInputsTab                matlab.ui.container.Tab
        SizeandMassPropertiesPanel      matlab.ui.container.Panel
        CenterofmasslocationmmPanel     matlab.ui.container.Panel
        XLabel                          matlab.ui.control.Label
        XEditField                      matlab.ui.control.NumericEditField
        YEditFieldLabel                 matlab.ui.control.Label
        YEditField                      matlab.ui.control.NumericEditField
        ZEditFieldLabel                 matlab.ui.control.Label
        ZEditField                      matlab.ui.control.NumericEditField
        SizeLabel                       matlab.ui.control.Label
        SizeDropDown                    matlab.ui.control.DropDown
        SatellitemassminusboomkgLabel   matlab.ui.control.Label
        SatellitemassminusboomkgEditField  matlab.ui.control.NumericEditField
        PassiveMagneticComponentsPanel  matlab.ui.container.Panel
        PermanentdipoleATM2Panel        matlab.ui.container.Panel
        XEditField_2Label               matlab.ui.control.Label
        XEditField_2                    matlab.ui.control.NumericEditField
        YEditField_2Label               matlab.ui.control.Label
        YEditField_2                    matlab.ui.control.NumericEditField
        ZEditField_2Label               matlab.ui.control.Label
        ZEditField_2                    matlab.ui.control.NumericEditField
        HysteresisrodpairsSpinnerLabel  matlab.ui.control.Label
        HysteresisrodpairsSpinner       matlab.ui.control.Spinner
        RodaxesDropDownLabel            matlab.ui.control.Label
        RodaxesDropDown                 matlab.ui.control.DropDown
        GravityBoomPanel                matlab.ui.container.Panel
        Switch                          matlab.ui.control.ToggleSwitch
        EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel  matlab.ui.control.Label
        EndmasskgEditField              matlab.ui.control.NumericEditField
        BoomlengthcmEditFieldLabel      matlab.ui.control.Label
        BoomlengthcmEditField           matlab.ui.control.NumericEditField
        DeploymentlatitudedegEditFieldLabel  matlab.ui.control.Label
        DeploymentlatitudedegEditField  matlab.ui.control.NumericEditField
        BoomdeploymenttriggersLabel     matlab.ui.control.Label
        LatitudeCheckBox                matlab.ui.control.CheckBox
        AttitudedeterminationCheckBox   matlab.ui.control.CheckBox
        OrientationSwitchLabel          matlab.ui.control.Label
        OrientationSwitch               matlab.ui.control.ToggleSwitch
        ADtriggerdurationminEditFieldLabel  matlab.ui.control.Label
        ADtriggerdurationminEditField   matlab.ui.control.NumericEditField
        ValidateButton                  matlab.ui.control.Button
        ResetButton                     matlab.ui.control.Button
        CubeSatParametersLabel          matlab.ui.control.Label
        ActiveMagneticComponentsPanel   matlab.ui.container.Panel
        Switch_2                        matlab.ui.control.Switch
        TorqueroddipoleATM2EditFieldLabel  matlab.ui.control.Label
        TorqueroddipoleATM2EditField    matlab.ui.control.NumericEditField
        TriggerlatitudedegEditFieldLabel  matlab.ui.control.Label
        TriggerlatitudedegEditField     matlab.ui.control.NumericEditField
        TorquerodaxisDropDownLabel      matlab.ui.control.Label
        TorquerodaxisDropDown           matlab.ui.control.DropDown
        TorquerodtriggerSwitch          matlab.ui.control.ToggleSwitch
        SimulationInputsTab             matlab.ui.container.Tab
        SimulationParametersLabel       matlab.ui.control.Label
        OrbitInformationPanel           matlab.ui.container.Panel
        GridLayout                      matlab.ui.container.GridLayout
        OrbitLabel                      matlab.ui.control.Label
        OrbitDropDown                   matlab.ui.control.DropDown
        SemimajorAxiskmEditFieldLabel   matlab.ui.control.Label
        SemimajorAxiskmEditField        matlab.ui.control.NumericEditField
        InclinationdegEditFieldLabel    matlab.ui.control.Label
        InclinationdegEditField         matlab.ui.control.NumericEditField
        LongofAscNodedegEditFieldLabel  matlab.ui.control.Label
        LongofAscNodedegEditField       matlab.ui.control.NumericEditField
        ArgofPeriapsedegLabel           matlab.ui.control.Label
        ArgofPeriapsedegEditField       matlab.ui.control.NumericEditField
        EccentricityLabel               matlab.ui.control.Label
        EccentricityEditField           matlab.ui.control.NumericEditField
        MeanAnomalydegLabel             matlab.ui.control.Label
        MeanAnomalydegEditField         matlab.ui.control.NumericEditField
        AltitudekmEditFieldLabel        matlab.ui.control.Label
        AltitudekmEditField             matlab.ui.control.NumericEditField
        InitialtipoffratesPanel         matlab.ui.container.Panel
        GridLayout3                     matlab.ui.container.GridLayout
        XdegsEditFieldLabel             matlab.ui.control.Label
        XdegsEditField                  matlab.ui.control.NumericEditField
        YdegsEditFieldLabel             matlab.ui.control.Label
        YdegsEditField                  matlab.ui.control.NumericEditField
        ZdegsEditFieldLabel             matlab.ui.control.Label
        ZdegsEditField                  matlab.ui.control.NumericEditField
        SimulationPanel                 matlab.ui.container.Panel
        GridLayout2                     matlab.ui.container.GridLayout
        StartDateLabel                  matlab.ui.control.Label
        StartDateDatePicker             matlab.ui.control.DatePicker
        SimulationdurationorbitsEditFieldLabel  matlab.ui.control.Label
        SimulationdurationorbitsEditField  matlab.ui.control.NumericEditField
        NadirpointingreqdegEditFieldLabel  matlab.ui.control.Label
        NadirpointingreqdegEditField    matlab.ui.control.NumericEditField
        DesiredofnadirpointingEditFieldLabel  matlab.ui.control.Label
        DesiredofnadirpointingEditField  matlab.ui.control.NumericEditField
        NorthpointingreqdegEditFieldLabel  matlab.ui.control.Label
        NorthpointingreqdegEditField    matlab.ui.control.NumericEditField
        DesiredofnorthpointingEditFieldLabel  matlab.ui.control.Label
        DesiredofnorthpointingEditField  matlab.ui.control.NumericEditField
        TimestepsEditFieldLabel         matlab.ui.control.Label
        TimestepsEditField              matlab.ui.control.NumericEditField
        RunSimulationButton             matlab.ui.control.Button
        DetumbleSuccessCriteriaPanel    matlab.ui.container.Panel
        RadiodetumblethresholdrpmEditFieldLabel  matlab.ui.control.Label
        RadiodetumblethresholdrpmEditField  matlab.ui.control.NumericEditField
        AttitudedetumblethresholddegsEditFieldLabel  matlab.ui.control.Label
        AttitudedetumblethresholddegsEditField  matlab.ui.control.NumericEditField
        AttitudedetumbledurationminEditFieldLabel  matlab.ui.control.Label
        AttitudedetumbledurationminEditField  matlab.ui.control.NumericEditField
        AttitudeDeterminationPanel      matlab.ui.container.Panel
        GridLayout14                    matlab.ui.container.GridLayout
        IMUsampleperiodsecEditFieldLabel  matlab.ui.control.Label
        IMUsampleperiodsecEditField     matlab.ui.control.NumericEditField
        IRsensorFOVhalfangledegEditFieldLabel  matlab.ui.control.Label
        IRsensorFOVhalfangledegEditField  matlab.ui.control.NumericEditField
        IRsensortriggerdeviationdegEditFieldLabel  matlab.ui.control.Label
        IRsensortriggerdeviationdegEditField  matlab.ui.control.NumericEditField
        ComputeAerodynamicsKnobLabel    matlab.ui.control.Label
        ComputeAerodynamicsKnob         matlab.ui.control.DiscreteKnob
        LoadfromFilePanel               matlab.ui.container.Panel
        FileNameLabel                   matlab.ui.control.Label
        FileNameEditField               matlab.ui.control.EditField
        LoadButton                      matlab.ui.control.Button
        SavetoFilePanel                 matlab.ui.container.Panel
        SaveButton                      matlab.ui.control.Button
        FileNameEditField_2Label        matlab.ui.control.Label
        FileNameEditField_2             matlab.ui.control.EditField
        OrbitVisualizationTab           matlab.ui.container.Tab
        OrbitInformationLLACoordinatesPanel  matlab.ui.container.Panel
        GridLayout5                     matlab.ui.container.GridLayout
        OrbitX                          matlab.ui.control.UIAxes
        OrbitY                          matlab.ui.control.UIAxes
        OrbitZ                          matlab.ui.control.UIAxes
        DisplayGroundTrackButton        matlab.ui.control.Button
        Display3DOrbitButton            matlab.ui.control.Button
        DisturbancesTab                 matlab.ui.container.Tab
        TabGroup3                       matlab.ui.container.TabGroup
        Torques1Tab                     matlab.ui.container.Tab
        MagneticTorquesPanel            matlab.ui.container.Panel
        GridLayout4_7                   matlab.ui.container.GridLayout
        MagTorqueX                      matlab.ui.control.UIAxes
        MagTorqueY                      matlab.ui.control.UIAxes
        MagTorqueZ                      matlab.ui.control.UIAxes
        HysteresisDampingTorquesPanel   matlab.ui.container.Panel
        GridLayout4_9                   matlab.ui.container.GridLayout
        HystTorqueX                     matlab.ui.control.UIAxes
        HystTorqueY                     matlab.ui.control.UIAxes
        HystTorqueZ                     matlab.ui.control.UIAxes
        GravityGradientTorquesPanel     matlab.ui.container.Panel
        GridLayout4_8                   matlab.ui.container.GridLayout
        GGTorqueX                       matlab.ui.control.UIAxes
        GGTorqueY                       matlab.ui.control.UIAxes
        GGTorqueZ                       matlab.ui.control.UIAxes
        Torques2Tab                     matlab.ui.container.Tab
        AerodynamicTorquesPanel         matlab.ui.container.Panel
        GridLayout4_12                  matlab.ui.container.GridLayout
        AeroTorqueX                     matlab.ui.control.UIAxes
        AeroTorqueY                     matlab.ui.control.UIAxes
        AeroTorqueZ                     matlab.ui.control.UIAxes
        OpticalTorquesPanel             matlab.ui.container.Panel
        GridLayout4_13                  matlab.ui.container.GridLayout
        OptTorqueX                      matlab.ui.control.UIAxes
        OptTorqueY                      matlab.ui.control.UIAxes
        OptTorqueZ                      matlab.ui.control.UIAxes
        MagneticFieldTab                matlab.ui.container.Tab
        MagneticFieldBodyFramePanel     matlab.ui.container.Panel
        GridLayout4_10                  matlab.ui.container.GridLayout
        Bx_body                         matlab.ui.control.UIAxes
        By_body                         matlab.ui.control.UIAxes
        Bz_body                         matlab.ui.control.UIAxes
        MagneticFieldLVLHPanel          matlab.ui.container.Panel
        GridLayout4_11                  matlab.ui.container.GridLayout
        Bx_LVLH                         matlab.ui.control.UIAxes
        By_LVLH                         matlab.ui.control.UIAxes
        Bz_LVLH                         matlab.ui.control.UIAxes
        AttitudeInformationTab          matlab.ui.container.Tab
        TabGroup2                       matlab.ui.container.TabGroup
        DetumbleTab                     matlab.ui.container.Tab
        TimeuntilattitudedetumbleorbitsEditFieldLabel  matlab.ui.control.Label
        TimeuntilattitudedetumbleorbitsEditField  matlab.ui.control.EditField
        TimeuntilattitudedetumbledaysEditFieldLabel  matlab.ui.control.Label
        TimeuntilattitudedetumbledaysEditField  matlab.ui.control.EditField
        BodyAngularRatesPanel_Detumble  matlab.ui.container.Panel
        GridLayout4_6                   matlab.ui.container.GridLayout
        roll_rate_detumble              matlab.ui.control.UIAxes
        pitch_rate_detumble             matlab.ui.control.UIAxes
        yaw_rate_detumble               matlab.ui.control.UIAxes
        HystAxes                        matlab.ui.control.UIAxes
        TimeuntilradiodetumbleorbitsEditFieldLabel  matlab.ui.control.Label
        TimeuntilradiodetumbleorbitsEditField  matlab.ui.control.EditField
        TimeuntilradiodetumbledaysEditFieldLabel  matlab.ui.control.Label
        TimeuntilradiodetumbledaysEditField  matlab.ui.control.EditField
        EulerAnglesTab                  matlab.ui.container.Tab
        EulerAnglesRollPitchYawPanel    matlab.ui.container.Panel
        GridLayout4                     matlab.ui.container.GridLayout
        Roll                            matlab.ui.control.UIAxes
        Pitch                           matlab.ui.control.UIAxes
        Yaw                             matlab.ui.control.UIAxes
        BodyAngularRatesPanel           matlab.ui.container.Panel
        GridLayout4_2                   matlab.ui.container.GridLayout
        roll_rate                       matlab.ui.control.UIAxes
        pitch_rate                      matlab.ui.control.UIAxes
        yaw_rate                        matlab.ui.control.UIAxes
        BodyAngularAccelerationsPanel   matlab.ui.container.Panel
        GridLayout4_3                   matlab.ui.container.GridLayout
        roll_acc                        matlab.ui.control.UIAxes
        pitch_acc                       matlab.ui.control.UIAxes
        yaw_acc                         matlab.ui.control.UIAxes
        PostDetumbleAttitudeInformationLabel  matlab.ui.control.Label
        DisplayAttitudeAnimationButton  matlab.ui.control.Button
        Speedfactor0to100EditFieldLabel  matlab.ui.control.Label
        Speedfactor0to100EditField      matlab.ui.control.NumericEditField
        PointingTab                     matlab.ui.container.Tab
        NadirAxes                       matlab.ui.control.UIAxes
        NorthAxes                       matlab.ui.control.UIAxes
        OrbitalperiodminEditFieldLabel  matlab.ui.control.Label
        Orbitalperiod                   matlab.ui.control.EditField
        MaximumdeviationafterdetumbledegLabel  matlab.ui.control.Label
        NadirDevMax                     matlab.ui.control.EditField
        PercentofpostsettlingtimemeetingrequirementEditFieldLabel  matlab.ui.control.Label
        NadirPctMet                     matlab.ui.control.EditField
        MaximumdeviationafterdetumbledegLabel_2  matlab.ui.control.Label
        NorthDevMax                     matlab.ui.control.EditField
        PercentofpostdetumbletimemeetingrequirementLabel  matlab.ui.control.Label
        NorthPctMet                     matlab.ui.control.EditField
        LatitudebelowwhichpointingrequirementpercentageismetdegLabel  matlab.ui.control.Label
        NorthLatIgnore                  matlab.ui.control.EditField
        PostDetumblePointingInformationLabel  matlab.ui.control.Label
        BoomdeploymenttimeorbitsEditFieldLabel  matlab.ui.control.Label
        BoomdeploymenttimeorbitsEditField  matlab.ui.control.EditField
        MiscTab                         matlab.ui.container.Tab
        FourierTransformsofRollPitchandYawRatesPanel  matlab.ui.container.Panel
        GridLayout4_14                  matlab.ui.container.GridLayout
        Roll_F                          matlab.ui.control.UIAxes
        Pitch_F                         matlab.ui.control.UIAxes
        Yaw_F                           matlab.ui.control.UIAxes
        AttitudeDeterminationTab        matlab.ui.container.Tab
        IntegratedEulerAnglesbasedonIMUdataPanel  matlab.ui.container.Panel
        GridLayout4_4                   matlab.ui.container.GridLayout
        Roll_IMU                        matlab.ui.control.UIAxes
        Pitch_IMU                       matlab.ui.control.UIAxes
        Yaw_IMU                         matlab.ui.control.UIAxes
        MinimumIMUsampleperiodforsmallerrorsecEditFieldLabel  matlab.ui.control.Label
        MinIMURate                      matlab.ui.control.EditField
        NominalangletohorizondegLabel   matlab.ui.control.Label
        HorizonAngle                    matlab.ui.control.EditField
        ZAxisBoresight                  matlab.ui.control.UIAxes
        AttitudeDeterminationBoresightDataPanel  matlab.ui.container.Panel
        GridLayout4_5                   matlab.ui.container.GridLayout
        PlusYBoresights                 matlab.ui.control.UIAxes
        MinusXBoresights                matlab.ui.control.UIAxes
        PlusXBoresights                 matlab.ui.control.UIAxes
        MinusYBoresights                matlab.ui.control.UIAxes
        Nadir_Reconstruction            matlab.ui.control.UIAxes
    end

    
    properties (Access = private)
        massLimit = 2.00;   % kg; 1U mass limit
        COMlimitXY = 20.0;  % mm; COM limits in X/Y
        COMlimitZ = 20.0;   % mm; COM limit in Z for 1U
        
        rE = Constant('equatorial radius earth');
        
        % CubeSat Parameters
        size = '1U';        % CubeSat size
        mass = 1.50;         % kg; CubeSat mass (minus boom end mass)
        COM = [0;0;0];      % m; COM position
        dipole = [0;0;0];   % ATM^2; CubeSat dipole
        rod_pairs = 0;      % hysteresis rod pairs
        rod_u = [[1;0;0] [0;1;0]];  % unit vectors of hysteresis rods (X and Y)
        gravity_boom = false;       % presence of gravity boom
        boom_end_mass = 0;  % kg; gravity boom end mass
        boom_length = 40;   % cm; gravity boom extension from geometric center
        boom_zenith = true; % boom points away from Earth
        active_system = false;  % presence of active magnetic control
        active_dipole = 0;  % ATM^2; active dipole
        active_dipole_axis = 'Z';   % axis of active dipole (torque rod)
        trigger_lat = 'initial';    % deg; trigger latitude for active magnetic control (can also have value 'initial')
        boom_lat = 0;       % deg; latitude for gravity boom deployment
        require_lat = true; % is meeting the boom deployment latitude required?
        require_AD = false; % is verification from the attitude determination subsystem required for boom deployment?
        AD_trigger_duration = 0; % min; length of time AD verification must be met for boom deployment
        %off_lat = 0;        % deg; off-trigger latitude for active magnetic control
        
        
        % Simulation Parameters
        start_date = Date2JD;   % JD; start date of simulation (default: today)
        el = [0 0 0 0 0 0];     % orbital elements (angles in radians) [a i W w e M]
        duration = 50;          % orbits; simulation duration (default 50 orbits)
        timestep = 2.5;         % sec; simulation time step (default 2.5 s)
        nadir_pointing_req = 5;     % +/- deg; pointing requirement to nadir (default +/- 5 deg)
        nadir_req_pct = 100;        % percent; desired fraction of time meeting nadir pointing req (default 100%)
        north_pointing_req = 5;     % +/- deg; pointing requirement to magnetic north (default +/- 5 deg)
        north_req_pct = 100;        % percent; desired fraction of time meeting north pointing req (default 100%)
        imu_period = 60;            % sec; IMU sample period (default 60 s)
        IR_FOV_half_angle = 0.5;    % deg; half-angle of IR sensor FOV (default 0.5 deg)
        IR_trigger_angle = 10;      % deg; deviation from nadir that triggers IR sensors (default 10 deg)
        IR_elevation = 0;           % deg; elevation angle of IR sensors on +/- X/Y faces (default acos(rE/(rE+h)) + IR trigger deviation - FOV half-angle)
        tipoff_rates = [0;0;0];     % rad/s; initial tipoff rates
        radio_detumble_rate = 3*2*pi/60;        % rad/s; instantaneous rate to be considered detumbled for radio communication
        attitude_detumble_rate = 0.1*pi/180;    % rad/s; instantaneous rate to be considered detumbled for attitude consideration
        attitude_detumble_duration = 0;         % min; duration for which attitude detumble condition must be satisfied
        aero_calc = 1;          % whether or not the simulation computes the aerodynamic forces on the satellite
                                % 1 = never, 2 = after boom deployment, 3 = always
        
        
        % Simulation outputs
        xOut    = [];       % Time history of state
        tPlot   = [];       % Time series
        simData = struct;   % Simulation data
        satellite = struct;
        simulation = struct;
        
        % Additional properties
        speed_factor = 100; % Speed factor for quaternion animation
    end
    
    methods (Access = private)
        
        function alert(app, message)
            fig = app.CubeSatADSSDesignandSimulationUIFigure;
            uialert(fig,message,'Warning','Icon','warning');
        end
    end
    

    % Callbacks that handle component events
    methods (Access = private)

        % Value changed function: SizeDropDown
        function SizeDropDownValueChanged(app, event)
            value = app.SizeDropDown.Value;
            if strcmp(value,'1U')
                app.massLimit = 2.00;
                app.COMlimitZ = 20.0;
            elseif strcmp(value,'1.5U')
                app.massLimit = 3.00;
                app.COMlimitZ = 30.0;
            elseif strcmp(value,'2U')
                app.massLimit = 4.00;
                app.COMlimitZ = 45.0;
            elseif strcmp(value,'3U')
                app.massLimit = 6.00;
                app.COMlimitZ = 70.0;
            end
            
            app.mass = 0.75*app.massLimit;
            app.SatellitemassminusboomkgEditField.Value = app.mass;
            app.size = value;
        end

        % Value changed function: SatellitemassminusboomkgEditField
        function SatellitemassminusboomkgEditFieldValueChanged(app, event)
            value = app.SatellitemassminusboomkgEditField.Value;
            app.mass = value;
            
            if ~app.gravity_boom && (app.mass > app.massLimit)
                message = sprintf('Invalid mass. \n Please enter a mass between 0.00 kg and %0.2f kg.', app.massLimit);
                alert(app,message);
            elseif app.gravity_boom && (app.mass + app.boom_end_mass > app.massLimit)
                message = sprintf('Invalid total mass. \n Please enter a mass between 0.00 kg and %0.2f kg.', app.massLimit - app.boom_end_mass);
                alert(app,message);
            end
        end

        % Value changed function: XEditField
        function XEditFieldValueChanged(app, event)
            value = app.XEditField.Value;
            if abs(value) > app.COMlimitXY
                message = sprintf(['Invalid COM location in the X direction. \n' ...
                    'Please enter a location between +/- %0.0f mm'], app.COMlimitXY);
                alert(app,message);
            end
            app.COM(1) = value/1000;
        end

        % Value changed function: YEditField
        function YEditFieldValueChanged(app, event)
            value = app.YEditField.Value;
            if abs(value) > app.COMlimitXY
                message = sprintf(['Invalid COM location in the Y direction. \n' ...
                    'Please enter a location between +/- %0.0f mm'], app.COMlimitXY);
                alert(app,message);
            end
            app.COM(2) = value/1000;
        end

        % Value changed function: ZEditField
        function ZEditFieldValueChanged(app, event)
            value = app.ZEditField.Value;
            if abs(value) > app.COMlimitZ
                message = sprintf(['Invalid COM location in the Z direction. \n' ...
                    'Please enter a location between +/- %0.0f mm'], app.COMlimitZ);
                alert(app,message);
            end
            app.COM(3) = value/1000;
        end

        % Value changed function: HysteresisrodpairsSpinner
        function HysteresisrodpairsSpinnerValueChanged(app, event)
            value = app.HysteresisrodpairsSpinner.Value;
            if value == 1
%                 app.FirstpairdistancefromfacemmEditField.Visible = true;
%                 app.FirstpairdistancefromfacemmLabel.Visible = true;
%                 app.SpacingbetweenrodpairsmmEditField.Visible = false;
%                 app.SpacingbetweenrodpairsmmEditFieldLabel.Visible = false;
                app.RodaxesDropDown.Visible = true;
                app.RodaxesDropDownLabel.Visible = true;
            end
%             if value > 1
%                 app.SpacingbetweenrodpairsmmEditField.Visible = true;
%                 app.SpacingbetweenrodpairsmmEditFieldLabel.Visible = true;
%             end
            if value == 0
%                 app.FirstpairdistancefromfacemmEditField.Visible = false;
%                 app.FirstpairdistancefromfacemmLabel.Visible = false;
%                 app.SpacingbetweenrodpairsmmEditField.Visible = false;
%                 app.SpacingbetweenrodpairsmmEditFieldLabel.Visible = false;
                app.RodaxesDropDown.Visible = false;
                app.RodaxesDropDownLabel.Visible = false;
            end
            
            app.rod_pairs = value;
        end

        % Callback function
        function FirstpairdistancefromfacemmEditFieldValueChanged(app, event)
%             value = app.FirstpairdistancefromfacemmEditField.Value;
%             app.first_pair_location = value;
        end

        % Callback function
        function SpacingbetweenrodpairsmmEditFieldValueChanged(app, event)
%             value = app.SpacingbetweenrodpairsmmEditField.Value;
%             app.rod_pair_spacing = value;
        end

        % Value changed function: Switch
        function SwitchValueChanged(app, event)
            value = app.Switch.Value;
            if strcmp(value,'On')
                app.gravity_boom = true;
                
                app.EndmasskgEditField.Visible = true;
                app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel.Visible = true;
                app.BoomlengthcmEditField.Visible = true;
                app.BoomlengthcmEditFieldLabel.Visible = true;
                app.OrientationSwitch.Visible = true;
                app.OrientationSwitchLabel.Visible = true;
                if app.AttitudedeterminationCheckBox.Value
                    app.ADtriggerdurationminEditField.Visible = true;
                    app.ADtriggerdurationminEditFieldLabel.Visible = true;
                end
                if app.LatitudeCheckBox.Value
                    app.DeploymentlatitudedegEditField.Visible = true;
                    app.DeploymentlatitudedegEditFieldLabel.Visible = true;
                end
                app.BoomdeploymenttriggersLabel.Visible = true;
                app.LatitudeCheckBox.Visible = true;
                app.AttitudedeterminationCheckBox.Visible = true;
            elseif strcmp(value,'Off')
                app.gravity_boom = false;
                
                app.EndmasskgEditField.Visible = false;
                app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel.Visible = false;
                app.BoomlengthcmEditField.Visible = false;
                app.BoomlengthcmEditFieldLabel.Visible = false;
                app.OrientationSwitch.Visible = false;
                app.OrientationSwitchLabel.Visible = false;
                app.ADtriggerdurationminEditField.Visible = false;
                app.ADtriggerdurationminEditFieldLabel.Visible = false;
                app.DeploymentlatitudedegEditField.Visible = false;
                app.DeploymentlatitudedegEditFieldLabel.Visible = false;
                app.BoomdeploymenttriggersLabel.Visible = false;
                app.LatitudeCheckBox.Visible = false;
                app.AttitudedeterminationCheckBox.Visible = false;
            end
        end

        % Value changed function: EndmasskgEditField
        function EndmasskgEditFieldValueChanged(app, event)
            value = app.EndmasskgEditField.Value;
            app.boom_end_mass = value;
            if app.gravity_boom && app.boom_end_mass + app.mass > app.massLimit
                message = sprintf(['Invalid boom end mass. \n' ...
                    'Please enter a mass between 0.00 kg and %0.2f kg'], app.massLimit - app.mass);
                alert(app,message);
            end
        end

        % Value changed function: BoomlengthcmEditField
        function BoomlengthcmEditFieldValueChanged(app, event)
            value = app.BoomlengthcmEditField.Value;
            app.boom_length = value;
        end

        % Value changed function: XEditField_2
        function XEditField_2ValueChanged(app, event)
            value = app.XEditField_2.Value;
            app.dipole(1) = value;
        end

        % Value changed function: YEditField_2
        function YEditField_2ValueChanged(app, event)
            value = app.YEditField_2.Value;
            app.dipole(2) = value;
        end

        % Value changed function: ZEditField_2
        function ZEditField_2ValueChanged(app, event)
            value = app.ZEditField_2.Value;
            app.dipole(3) = value;
        end

        % Button pushed function: ValidateButton
        function ValidateButtonPushed(app, event)
            cds_compliant = ~(abs(app.COM(1)) > app.COMlimitXY/1000 || abs(app.COM(2)) > app.COMlimitXY/1000 || ...
                abs(app.COM(3)) > app.COMlimitZ/1000 || (~app.gravity_boom && app.mass > app.massLimit) || ...
                (app.gravity_boom && app.mass + app.boom_end_mass > app.massLimit));
            
            if app.gravity_boom
                if app.active_system
                    message = sprintf(['Size: ' app.size '\nCOM: [%.3f, %.3f, %.3f]\nDipole: [%.3f, %.3f, %.3f]' ...
                    '\nRod pairs: %d\nGravity boom: ' mat2str(app.gravity_boom) ...
                    '\nMass: %.2f\nBoom length: %.1f\nBoom end mass: %.2f\nCDS compliant: ' mat2str(cds_compliant) ...
                    '\nActive magnetic system: ' mat2str(app.active_system) '\nActive dipole: %.3f' ...
                    '\nBoom deployment latitude: %.1f'], ...
                    app.COM(1),app.COM(2),app.COM(3), ...
                    app.dipole(2),app.dipole(2),app.dipole(3), ...
                    app.rod_pairs, ...
                    app.mass,app.boom_length,app.boom_end_mass,app.active_dipole,app.boom_lat);
                else
                    message = sprintf(['Size: ' app.size '\nCOM: [%.3f, %.3f, %.3f]\nDipole: [%.3f, %.3f, %.3f]' ...
                    '\nRod pairs: %d\nGravity boom: ' mat2str(app.gravity_boom) ...
                    '\nMass: %.2f\nBoom length: %.1f\nBoom end mass: %.2f\nCDS compliant: ' mat2str(cds_compliant) ...
                    '\nActive magnetic system: ' mat2str(app.active_system)], ...
                    app.COM(1),app.COM(2),app.COM(3), ...
                    app.dipole(2),app.dipole(2),app.dipole(3), ...
                    app.rod_pairs, ...
                    app.mass,app.boom_length,app.boom_end_mass);
                end
            else
                if app.active_system
                    message = sprintf(['Size: ' app.size '\nCOM: [%.3f, %.3f, %.3f]\nDipole: [%.3f, %.3f, %.3f]' ...
                    '\nRod pairs: %d\nGravity boom: ' mat2str(app.gravity_boom) ...
                    '\nMass: %.2f\nCDS compliant: ' mat2str(cds_compliant) ...
                    '\nActive magnetic system: ' mat2str(app.active_system) '\nActive dipole: %.3f' ...
                    '\nBoom deployment latitude: %.1f'], ...
                    app.COM(1),app.COM(2),app.COM(3), ...
                    app.dipole(2),app.dipole(2),app.dipole(3), ...
                    app.rod_pairs,app.mass, ...
                    app.active_dipole,app.boom_lat);
                else
                    message = sprintf(['Size: ' app.size '\nCOM: [%.3f, %.3f, %.3f]\nDipole: [%.3f, %.3f, %.3f]' ...
                    '\nRod pairs: %d\nGravity boom: ' mat2str(app.gravity_boom) ...
                    '\nMass: %.2f\nCDS compliant: ' mat2str(cds_compliant) ...
                    '\nActive magnetic system: ' mat2str(app.active_system)], ...
                    app.COM(1),app.COM(2),app.COM(3), ...
                    app.dipole(2),app.dipole(2),app.dipole(3), ...
                    app.rod_pairs,app.mass);
                end
            end
            
            if cds_compliant
                icon = 'success';
            else
                icon = 'error';
            end
            
            uialert(app.CubeSatADSSDesignandSimulationUIFigure,message,'Test','Icon',icon); 
        end

        % Button pushed function: ResetButton
        function ResetButtonPushed(app, event)
            % Reset limits and properties
            app.massLimit = 2.00;   % kg; 1U mass limit
            app.COMlimitXY = 20.0;  % mm; COM limits in X/Y
            app.COMlimitZ = 20.0;   % mm; COM limit in Z for 1U
            
            app.size = '1U';        % CubeSat size
            app.mass = 1.50;         % kg; CubeSat mass
            app.COM = [0;0;0];      % m; COM position
            app.dipole = [0;0;0];   % ATM^2; CubeSat dipole
            app.rod_pairs = 0;      % hysteresis rod pairs
            app.rod_u = [[1;0;0] [0;1;0]];  % hysteresis rod unit vectors
%             app.first_pair_location = 15;   % mm; separation in Z between the back face of the CubeSat and the first pair of rods
%             app.rod_pair_spacing = 35;      % mm; spacing between pairs of hysteresis rods
            app.gravity_boom = false;       % presence of gravity boom
            app.boom_end_mass = 0;  % kg; gravity boom end mass
            app.boom_length = 40;   % cm; gravity boom extension from geometric center
            app.boom_zenith = true;
            app.active_system = false;
            app.active_dipole = 0;
            app.active_dipole_axis = 'Z';
            app.trigger_lat = 'initial';
            app.boom_lat = 0;
            app.require_lat = true;
            app.require_AD = false;
            
            % Reset displayed values and visibilities
            app.SizeDropDown.Value = app.size;
            app.SatellitemassminusboomkgEditField.Value = app.mass;
            app.XEditField.Value = app.COM(1);
            app.YEditField.Value = app.COM(2);
            app.ZEditField.Value = app.COM(3);
            app.XEditField_2.Value = app.dipole(1);
            app.YEditField_2.Value = app.dipole(2);
            app.ZEditField_2.Value = app.dipole(3);
            app.HysteresisrodpairsSpinner.Value = app.rod_pairs;
            app.RodaxesDropDown.Value = 'X and Y';
            app.RodaxesDropDown.Visible = false;
            app.RodaxesDropDownLabel.Visible = false;
%             app.FirstpairdistancefromfacemmEditField.Value = app.first_pair_location;
%             app.FirstpairdistancefromfacemmEditField.Visible = false;
%             app.FirstpairdistancefromfacemmLabel.Visible = false;
%             app.SpacingbetweenrodpairsmmEditField.Value = app.rod_pair_spacing;
%             app.SpacingbetweenrodpairsmmEditField.Visible = false;
%             app.SpacingbetweenrodpairsmmEditFieldLabel.Visible = false;
            app.Switch.Value = 'Off';
            app.EndmasskgEditField.Value = app.boom_end_mass;
            app.EndmasskgEditField.Visible = false;
            app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel.Visible = false;
            app.BoomlengthcmEditField.Value = app.boom_length;
            app.BoomlengthcmEditField.Visible = false;
            app.BoomlengthcmEditFieldLabel.Visible = false;
            app.OrientationSwitch.Visible = false;
            app.OrientationSwitchLabel.Visible = false;
            app.OrientationSwitch.Value = 'Zenith';
            app.ADtriggerdurationminEditField.Visible = false;
            app.ADtriggerdurationminEditFieldLabel.Visible = false;
            app.ADtriggerdurationminEditField.Value = 0;
            app.Switch_2.Value = 'Off';
            app.TorqueroddipoleATM2EditField.Value = app.active_dipole;
            app.TorqueroddipoleATM2EditField.Visible = false;
            app.TorqueroddipoleATM2EditFieldLabel.Visible = false;
            app.TorquerodaxisDropDown.Value = app.active_dipole_axis;
            app.TorquerodaxisDropDown.Visible = false;
            app.TorquerodaxisDropDownLabel.Visible = false;
            app.TriggerlatitudedegEditField.Value = 0;
            app.TriggerlatitudedegEditField.Visible = false;
            app.TriggerlatitudedegEditFieldLabel.Visible = false;
            app.DeploymentlatitudedegEditField.Value = app.boom_lat;
            app.DeploymentlatitudedegEditField.Visible = false;
            app.DeploymentlatitudedegEditFieldLabel.Visible = false;
            app.BoomdeploymenttriggersLabel.Visible = false;
            app.LatitudeCheckBox.Visible = false;
            app.LatitudeCheckBox.Value = 1;
            app.AttitudedeterminationCheckBox.Visible = false;
            app.AttitudedeterminationCheckBox.Value = 0;
%             app.OfftriggerlatitudedegEditField.Visible = false;
%             app.OfftriggerlatitudedegEditFieldLabel.Visible = false;
            app.TorquerodtriggerSwitch.Value = 'Triggered on (after detumble)';
            app.TorquerodtriggerSwitch.Visible = false;
        end

        % Value changed function: StartDateDatePicker
        function StartDateDatePickerValueChanged(app, event)
            value = app.StartDateDatePicker.Value;
            year = value.Year;
            month = value.Month;
            day = value.Day;
            
            date_vec = [year month day 0 0 0];
            
            app.start_date = Date2JD(date_vec);
        end

        % Value changed function: SimulationdurationorbitsEditField
        function SimulationdurationorbitsEditFieldValueChanged(app, event)
            value = app.SimulationdurationorbitsEditField.Value;
            app.duration = value;
        end

        % Value changed function: NadirpointingreqdegEditField
        function NadirpointingreqdegEditFieldValueChanged(app, event)
            value = app.NadirpointingreqdegEditField.Value;
            app.nadir_pointing_req = value;
        end

        % Value changed function: DesiredofnadirpointingEditField
        function DesiredofnadirpointingEditFieldValueChanged(app, event)
            value = app.DesiredofnadirpointingEditField.Value;
            app.nadir_req_pct = value;
        end

        % Value changed function: IMUsampleperiodsecEditField
        function IMUsampleperiodsecEditFieldValueChanged(app, event)
            value = app.IMUsampleperiodsecEditField.Value;
            app.imu_period = value;
        end

        % Value changed function: OrbitDropDown
        function OrbitDropDownValueChanged(app, event)
            value = app.OrbitDropDown.Value;
            if strcmp(value, 'Sun-Synch Polar (500 km)')
                a = app.rE + 500;
                i = 97*pi/180;
                
                app.el = [a i 0 0 0 0];
            elseif strcmp(value, 'ISS')
                a = app.rE + 419.5;
                i = 51.64*pi/180;
                W = 215.83*pi/180;
                w = 70.44*pi/180;
                e = 0.0000565;
                
                app.el = [a i W w e 0];
            elseif strcmp(value, 'Equatorial')
                a = app.rE + 500;
                
                app.el = [a 0 0 0 0 0];
            end
            
            app.SemimajorAxiskmEditField.Value = app.el(1);
            app.InclinationdegEditField.Value = app.el(2)*180/pi;
            app.LongofAscNodedegEditField.Value = app.el(3)*180/pi;
            app.ArgofPeriapsedegEditField.Value = app.el(4)*180/pi;
            app.EccentricityEditField.Value = app.el(5);
            app.MeanAnomalydegEditField.Value = app.el(6)*180/pi;
            
            h = app.el(1) - app.rE;
            app.AltitudekmEditField.Value = h;
            
            app.IR_elevation = acos(app.rE/(app.rE+h))*180/pi + app.IR_trigger_angle - app.IR_FOV_half_angle;
        end

        % Value changed function: AltitudekmEditField
        function AltitudekmEditFieldValueChanged(app, event)
            value = app.AltitudekmEditField.Value;
            
            app.el(1) = app.rE + value;
            app.SemimajorAxiskmEditField.Value = app.el(1);
            app.OrbitDropDown.Value = 'Custom';
            
            h = app.el(1) - app.rE;
            app.IR_elevation = acos(app.rE/(app.rE+h))*180/pi + app.IR_trigger_angle - app.IR_FOV_half_angle;
        end

        % Value changed function: SemimajorAxiskmEditField
        function SemimajorAxiskmEditFieldValueChanged(app, event)
            value = app.SemimajorAxiskmEditField.Value;
            
            app.el(1) = value;
            app.AltitudekmEditField.Value = app.el(1) - app.rE;
            app.OrbitDropDown.Value = 'Custom';
        end

        % Value changed function: InclinationdegEditField
        function InclinationdegEditFieldValueChanged(app, event)
            value = app.InclinationdegEditField.Value;
            app.el(2) = value*pi/180;
            app.OrbitDropDown.Value = 'Custom';
        end

        % Value changed function: LongofAscNodedegEditField
        function LongofAscNodedegEditFieldValueChanged(app, event)
            value = app.LongofAscNodedegEditField.Value;
            app.el(3) = value*pi/180;
            app.OrbitDropDown.Value = 'Custom';
        end

        % Value changed function: ArgofPeriapsedegEditField
        function ArgofPeriapsedegEditFieldValueChanged(app, event)
            value = app.ArgofPeriapsedegEditField.Value;
            app.el(4) = value*pi/180;
            app.OrbitDropDown.Value = 'Custom';
        end

        % Value changed function: EccentricityEditField
        function EccentricityEditFieldValueChanged(app, event)
            value = app.EccentricityEditField.Value;
            app.el(5) = value;
            app.OrbitDropDown.Value = 'Custom';
        end

        % Value changed function: MeanAnomalydegEditField
        function MeanAnomalydegEditFieldValueChanged(app, event)
            value = app.MeanAnomalydegEditField.Value;
            app.el(6) = value*pi/180;
            app.OrbitDropDown.Value = 'Custom';
        end

        % Value changed function: XdegsEditField
        function XdegsEditFieldValueChanged(app, event)
            value = app.XdegsEditField.Value;
            app.tipoff_rates(1) = value*pi/180;
        end

        % Value changed function: YdegsEditField
        function YdegsEditFieldValueChanged(app, event)
            value = app.YdegsEditField.Value;
            app.tipoff_rates(2) = value*pi/180;
        end

        % Value changed function: ZdegsEditField
        function ZdegsEditFieldValueChanged(app, event)
            value = app.ZdegsEditField.Value;
            app.tipoff_rates(3) = value*pi/180;
        end

        % Value changed function: Switch_2
        function Switch_2ValueChanged(app, event)
            value = app.Switch_2.Value;
            
            if strcmp(value,'On')
                app.active_system = true;
                
                app.TorqueroddipoleATM2EditField.Visible = true;
                app.TorqueroddipoleATM2EditFieldLabel.Visible = true;
                if strcmp(app.TorquerodtriggerSwitch.Value,'Triggered on')
                    app.TriggerlatitudedegEditField.Visible = true;
                    app.TriggerlatitudedegEditFieldLabel.Visible = true;
                end
%                 app.DeploymentlatitudedegEditField.Visible = true;
%                 app.DeploymentlatitudedegEditFieldLabel.Visible = true;
%                 app.OfftriggerlatitudedegEditField.Visible = true;
%                 app.OfftriggerlatitudedegEditFieldLabel.Visible = true;
                app.TorquerodaxisDropDown.Visible = true;
                app.TorquerodaxisDropDownLabel.Visible = true;
                app.TorquerodtriggerSwitch.Visible = true;
                
            elseif strcmp(value,'Off')
                app.active_system = false;
                
                app.TorqueroddipoleATM2EditField.Visible = false;
                app.TorqueroddipoleATM2EditFieldLabel.Visible = false;
                app.TriggerlatitudedegEditField.Visible = false;
                app.TriggerlatitudedegEditFieldLabel.Visible = false;
%                 app.DeploymentlatitudedegEditField.Visible = false;
%                 app.DeploymentlatitudedegEditFieldLabel.Visible = false;
%                 app.OfftriggerlatitudedegEditField.Visible = false;
%                 app.OfftriggerlatitudedegEditFieldLabel.Visible = false;
                app.TorquerodaxisDropDown.Visible = false;
                app.TorquerodaxisDropDownLabel.Visible = false;
                app.TorquerodtriggerSwitch.Visible = false;
                
            end
        end

        % Value changed function: TorqueroddipoleATM2EditField
        function TorqueroddipoleATM2EditFieldValueChanged(app, event)
            value = app.TorqueroddipoleATM2EditField.Value;
            
            app.active_dipole = value;
        end

        % Value changed function: TriggerlatitudedegEditField
        function TriggerlatitudedegEditFieldValueChanged(app, event)
            value = app.TriggerlatitudedegEditField.Value;
            
            app.trigger_lat = value;
        end

        % Value changed function: DeploymentlatitudedegEditField
        function DeploymentlatitudedegEditFieldValueChanged(app, event)
            value = app.DeploymentlatitudedegEditField.Value;
            
            app.boom_lat = value;
            
            % Update off-trigger latitude as well
            %app.off_lat = value;
            %app.OfftriggerlatitudedegEditField.Value = app.off_lat;
        end

        % Callback function
        function OfftriggerlatitudedegEditFieldValueChanged(app, event)
%             value = app.OfftriggerlatitudedegEditField.Value;
%             
%             app.off_lat = value;
        end

        % Callback function
        function PlotTestButtonPushed(app, event)
            
        end

        % Value changed function: RodaxesDropDown
        function RodaxesDropDownValueChanged(app, event)
            value = app.RodaxesDropDown.Value;
            
            if strcmp(value,'X and Y')
                app.rod_u = [[1;0;0] [0;1;0]];
            elseif strcmp(value,'X and Z')
                app.rod_u = [[1;0;0] [0;0;1]];
            elseif strcmp(value,'Y and Z')
                app.rod_u = [[0;1;0] [0;0;1]];
            end
        end

        % Value changed function: NorthpointingreqdegEditField
        function NorthpointingreqdegEditFieldValueChanged(app, event)
            value = app.NorthpointingreqdegEditField.Value;
            
            app.north_pointing_req = value;
        end

        % Value changed function: DesiredofnorthpointingEditField
        function DesiredofnorthpointingEditFieldValueChanged(app, event)
            value = app.DesiredofnorthpointingEditField.Value;
            
            app.nadir_req_pct = value;
        end

        % Value changed function: TorquerodaxisDropDown
        function TorquerodaxisDropDownValueChanged(app, event)
            value = app.TorquerodaxisDropDown.Value;
            app.active_dipole_axis = value;
        end

        % Value changed function: TorquerodtriggerSwitch
        function TorquerodtriggerSwitchValueChanged(app, event)
            value = app.TorquerodtriggerSwitch.Value;
            
            if strcmp(value,'Initially on')
                app.trigger_lat = 'initial';
                app.TriggerlatitudedegEditField.Visible = false;
                app.TriggerlatitudedegEditFieldLabel.Visible = false;
            elseif strcmp(value,'Triggered on (after detumble)')
                app.trigger_lat = app.TriggerlatitudedegEditField.Value;
                app.TriggerlatitudedegEditField.Visible = true;
                app.TriggerlatitudedegEditFieldLabel.Visible = true;
            end
        end

        % Value changed function: LatitudeCheckBox
        function LatitudeCheckBoxValueChanged(app, event)
            value = app.LatitudeCheckBox.Value;
            if value
                app.require_lat = true;
                app.DeploymentlatitudedegEditField.Visible = true;
                app.DeploymentlatitudedegEditFieldLabel.Visible = true;
            else
                app.require_lat = false;
                app.DeploymentlatitudedegEditField.Visible = false;
                app.DeploymentlatitudedegEditFieldLabel.Visible = false;
            end
        end

        % Value changed function: AttitudedeterminationCheckBox
        function AttitudedeterminationCheckBoxValueChanged(app, event)
            value = app.AttitudedeterminationCheckBox.Value;
            
            if value
                app.require_AD = true;
                app.ADtriggerdurationminEditField.Visible = true;
                app.ADtriggerdurationminEditFieldLabel.Visible = true;
            else
                app.require_AD = false;
                app.ADtriggerdurationminEditField.Visible = false;
                app.ADtriggerdurationminEditFieldLabel.Visible = false;
            end
        end

        % Callback function
        function ComputeAerodynamicsSwitchValueChanged(app, event)
%             value = app.ComputeAerodynamicsSwitch.Value;
%             
%             if strcmp(value,'On')
%                 app.aero_calc = true;
%             elseif strcmp(value,'Off')
%                 app.aero_calc = false;
%             end
        end

        % Value changed function: TimestepsEditField
        function TimestepsEditFieldValueChanged(app, event)
            value = app.TimestepsEditField.Value;
            app.timestep = value;
        end

        % Value changed function: IRsensorFOVhalfangledegEditField
        function IRsensorFOVhalfangledegEditFieldValueChanged(app, event)
            value = app.IRsensorFOVhalfangledegEditField.Value;
            app.IR_FOV_half_angle = value;
            
            h = app.el(1) - app.rE;
            app.IR_elevation = acos(app.rE/(app.rE+h))*180/pi + app.IR_trigger_angle - app.IR_FOV_half_angle;
        end

        % Value changed function: RadiodetumblethresholdrpmEditField
        function RadiodetumblethresholdrpmEditFieldValueChanged(app, event)
            value = app.RadiodetumblethresholdrpmEditField.Value;
            app.radio_detumble_rate = value*2*pi/60;
        end

        % Value changed function: 
        % AttitudedetumblethresholddegsEditField
        function AttitudedetumblethresholddegsEditFieldValueChanged(app, event)
            value = app.AttitudedetumblethresholddegsEditField.Value;
            app.attitude_detumble_rate = value*pi/180;
        end

        % Value changed function: 
        % IRsensortriggerdeviationdegEditField
        function IRsensortriggerdeviationdegEditFieldValueChanged(app, event)
            value = app.IRsensortriggerdeviationdegEditField.Value;
            app.IR_trigger_angle = value;
            
            h = app.el(1) - app.rE;
            app.IR_elevation = acos(app.rE/(app.rE+h))*180/pi + app.IR_trigger_angle - app.IR_FOV_half_angle;
        end

        % Button pushed function: RunSimulationButton
        function RunSimulationButtonPushed(app, event)
            sat = struct;   % instantiate the data structure containing information about the satellite
            sim = struct;   % instantiate the data structure containing information about the simulation
            
            % Define the satellite structure
            sat.size        = app.size;         % CubeSat size
            sat.satMass     = app.mass;         % kg; CubeSat mass (minus boom end mass)
            sat.COM         = app.COM;          % m; (3,1) center of mass position
            sat.dipole      = app.dipole;       % ATM^2; (3,1) permanent dipole
            sat.rod_pairs   = app.rod_pairs;    % hysteresis rod pairs
            sat.rod_u       = app.rod_u;        % hysteresis rod unit vectors
            
            if app.gravity_boom
                sat.boom.end_mass   = app.boom_end_mass;    % kg; gravity boom end 
                if app.boom_zenith
                    sat.boom.length = -1*app.boom_length;   % cm; extension from geometric center (zenith-pointing)
                else
                    sat.boom.length = app.boom_length;      % cm; extension from geometric center (nadir-pointing)
                end
                sat.boom.deploy_lat = app.boom_lat;         % deg; latitude for gravity boom deployment
                sat.boom.require_lat = app.require_lat;     % require meeting latitude for deployment?
                sat.boom.require_AD  = app.require_AD;      % require attitude determination verification for deployment?
                % if neither latitude nor attitude determination are
                % required, boom is just deployed initially
                sat.boom.AD_duration = app.AD_trigger_duration; % min; length of required AD verification
            else
                sat.boom = [];      % no gravity boom
            end
            
            if app.active_system
                switch app.active_dipole_axis
                    case 'X'
                        sat.active.dipole = [app.active_dipole;0;0];    % ATM^2; active dipole (torque rod)
                    case 'Y'
                        sat.active.dipole = [0;app.active_dipole;0];    % ATM^2; active dipole (torque rod)
                    case 'Z'
                        sat.active.dipole = [0;0;app.active_dipole];    % ATM^2; active dipole (torque rod)
                end
                sat.active.trigger_lat = app.trigger_lat;   % deg; trigger latitude for active magnetic control
                % if sat.active.trigger_lat = 'initial', then the torque
                % rod is initially on
            else
                sat.active = [];    % no active system
            end
            
            % Define the simulation structure
            sim.jD0     = app.start_date;   % JD; start date of simulation
            sim.el      = app.el;           % (1,6) orbital elements (angles in radians) [a i W w e M]
            sim.numOrbits = app.duration;   % orbits; simulation duration
            sim.dT      = app.timestep;     % seconds; simulation time step
            sim.nadir_req = app.nadir_pointing_req;     % +/- deg; pointing requirement to nadir
            sim.nadir_req_pct = app.nadir_req_pct;      % percent; desired fraction of time meeting nadir pointing requirement
            sim.north_req = app.north_pointing_req;     % +/i deg; pointing requirement to magnetic north
            sim.north_req_pct = app.north_req_pct;      % percent; desired fraction of time meeting north pointing requirement
            sim.AD.imu_pd = app.imu_period;             % seconds; IMU sample period
            sim.AD.half_angle = app.IR_FOV_half_angle;  % deg; half-angle of IR sensor FOV
            sim.AD.trigger = app.IR_trigger_angle;      % deg; deviation from nadir that triggers IR sensors
            sim.AD.elevation = app.IR_elevation;        % deg; elevation angle of IR sensors on +/- X/Y faces
            sim.w0      = app.tipoff_rates;             % rad/s; (3,1) initial tipoff rates
            sim.radio_detumble  = app.radio_detumble_rate;        % rad/s; instantaneous rate to be considered detumbled for comms
            sim.att_detumble    = app.attitude_detumble_rate;     % rad/s; instantaneous rate to be considered detumbled for attitude
            sim.att_dt_duration = app.attitude_detumble_duration; % min; duration meeting attitude detumble criterion
            sim.aero_calc   = app.aero_calc;    % 1, 2, or 3; whether or not simulation compute aerodynamic forces
            
            %----- Call simulation function -----%
            [x,t,sim_Data] = CubeSatSimulation(sat,sim);
            
            % Make accessible outside this function
            app.xOut        = x;
            app.tPlot       = t;
            app.simData     = sim_Data;
            app.satellite   = sat;
            app.simulation  = sim;
            
            % Make 'Save' button visible
            app.SaveButton.Visible = true;
            
            % If certain conditions were not met, throw a warning
            warning = "";
            if sim_Data.att_DT_time == -1
                warning = "ERROR: The attitude detumble condition was never met." + newline;
            end
            if app.active_system && sim_Data.torquerod_time(1) == -1
                warning = warning + "ERROR: Torque rod condition to turn on was never met." + newline;
            end
            if app.active_system && sim_Data.torquerod_time(2) == -1
                warning = warning + "ERROR: Torque rod condition to turn off was never met." + newline;
            end
            if app.gravity_boom && sim_Data.boom_deploy == -1
                warning = warning + "ERROR: The gravity boom deployment condition was never met.";
            end
            
            if strcmp(warning,"")
                fig = app.CubeSatADSSDesignandSimulationUIFigure;
                message = 'SUCCESS: Simulation proceeded as expected.';
                uialert(fig,message,'Simulation Complete','Icon','success');
            else
                fig = app.CubeSatADSSDesignandSimulationUIFigure;
                uialert(fig,warning,'Warning','Icon','error');
            end
            
            
            %-------------------- Plot data to axes --------------------%
            pOrb = sim_Data.pOrb;
            app.CubeSatADSSDesignandSimulationUIFigure.AutoResizeChildren = 'off';
            
            % Orbit information
            orb_axes = [app.OrbitX app.OrbitY app.OrbitZ];
            PlotApp(orb_axes, t/pOrb, sim_Data.lla);
            
            %----- Disturbance torques -----%
            mag_axes = [app.MagTorqueX app.MagTorqueY app.MagTorqueZ];
            PlotApp(mag_axes, t/pOrb, sim_Data.dist.tMag);
            
            hyst_axes = [app.HystTorqueX app.HystTorqueY app.HystTorqueZ];
            PlotApp(hyst_axes, t/pOrb, sim_Data.dist.tHyst);
            
            gg_axes = [app.GGTorqueX app.GGTorqueY app.GGTorqueZ];
            PlotApp(gg_axes, t/pOrb, sim_Data.dist.tGG);
            
            aero_axes = [app.AeroTorqueX app.AeroTorqueY app.AeroTorqueZ];
            PlotApp(aero_axes, t/pOrb, sim_Data.dist.tAero);
            
            opt_axes = [app.OptTorqueX app.OptTorqueY app.OptTorqueZ];
            PlotApp(opt_axes, t/pOrb, sim_Data.dist.tOpt);
            
            %----- Magnetic field -----%
            bbody_axes = [app.Bx_body app.By_body app.Bz_body];
            PlotApp(bbody_axes, t/pOrb, sim_Data.bFieldBody);
            
            blvlh_axes = [app.Bx_LVLH app.By_LVLH app.Bz_LVLH];
            PlotApp(blvlh_axes, t/pOrb, sim_Data.bFieldLVLH);
            
            
            %----- Detumble times -----%
            if sim_Data.att_DT_time ~= -1
                att_detumble_sec = (sim_Data.att_DT_time - 1) * sim.dT;
                att_detumble_orb = att_detumble_sec / pOrb;
                att_detumble_day = att_detumble_sec / 86400;
            
                app.TimeuntilattitudedetumbleorbitsEditField.Value = num2str(att_detumble_orb,'%.2f');
                app.TimeuntilattitudedetumbledaysEditField.Value = num2str(att_detumble_day,'%.2f');
                
            else % the attitude detumble condition was never reached
                app.TimeuntilattitudedetumbleorbitsEditField.Value = 'N/A';
                app.TimeuntilattitudedetumbledaysEditField.Value = 'N/A';
            end
            
            if sim_Data.radio_DT_time ~= -1
                radio_detumble_sec = (sim_Data.radio_DT_time - 1) * sim.dT;
                radio_detumble_orb = radio_detumble_sec / pOrb;
                radio_detumble_day = radio_detumble_sec / 86400;
            
                app.TimeuntilradiodetumbleorbitsEditField.Value = num2str(radio_detumble_orb,'%.2f');
                app.TimeuntilradiodetumbledaysEditField.Value = num2str(radio_detumble_day,'%.2f');
                
            else % the radio detumble condition was never reached
                app.TimeuntilradiodetumbleorbitsEditField.Value = 'N/A';
                app.TimeuntilradiodetumbledaysEditField.Value = 'N/A'; 
            end
            
            % Hysteresis loop sample
            if app.rod_pairs > 0
                app.HystAxes.Visible = true;
                PlotApp(app.HystAxes, sim_Data.dist.rodH(1,:), x(15,:));
            else
                app.HystAxes.Visible = false;
            end
            
            %----- Attitude rates during detumble -----%
            dt_axes = [app.roll_rate_detumble app.pitch_rate_detumble app.yaw_rate_detumble];
            if sim_Data.att_DT_time == -1 % the attitude detumble condition was never reached; plot all data
                PlotApp(dt_axes, t/pOrb, x(11:13,:)*180/pi);
                
            elseif sim_Data.att_DT_time ~= 1 % attitude detumble condition is not met initially
                dt_ind = sim_Data.att_DT_time;
                PlotApp(dt_axes, t(1:dt_ind)/pOrb, x(11:13,1:dt_ind)*180/pi);
                
            end
            
            %------ Attitude rates post-detumble ------%
            if sim_Data.att_DT_time ~= -1 % the attitude detumble condition was reached at some point
                dt_ind = sim_Data.att_DT_time;
                
                eul_ax  = [app.Roll app.Pitch app.Yaw];
                rate_ax = [app.roll_rate app.pitch_rate app.yaw_rate];
                acc_ax  = [app.roll_acc app.pitch_acc app.yaw_acc];
                
                PlotApp(eul_ax, t(dt_ind:end)/pOrb, sim_Data.eul(:,dt_ind:end)*180/pi);
                PlotApp(rate_ax, t(dt_ind:end)/pOrb, x(11:13,dt_ind:end)*180/pi);
                PlotApp(acc_ax, t(dt_ind:end)/pOrb, sim_Data.alpha(:,dt_ind:end)*180/pi);
            else
                dt_ind = length(t);
            end
            
            %-------------- Pointing tab --------------%
            % Plot pointing errors
            if sim_Data.att_DT_time ~= -1 % the attitude detumble condition was reached at some point
                dt_ind = sim_Data.att_DT_time;
                
                nadir_data = [sim_Data.nadir(dt_ind:end)*180/pi; app.nadir_pointing_req*ones(1,length(t)-dt_ind+1)];
                PlotApp(app.NadirAxes, t(dt_ind:end)/pOrb,nadir_data);
                
                north_data = [sim_Data.north(dt_ind:end)*180/pi; app.north_pointing_req*ones(1,length(t)-dt_ind+1)];
                PlotApp(app.NorthAxes, t(dt_ind:end)/pOrb, north_data);
                
                if app.gravity_boom && sim_Data.boom_deploy >= sim_Data.att_DT_time
                    xline(app.NadirAxes,t(sim_Data.boom_deploy)/pOrb,'-','Boom Deployment');
                    grid(app.NadirAxes,'on');
                    
                    xline(app.NorthAxes,t(sim_Data.boom_deploy)/pOrb,'-','Boom Deployment');
                    grid(app.NorthAxes,'on');
                end
                
                
            else
                app.NadirAxes.Visible = false;
                app.NorthAxes.Visible = false;
            end
            
            %----- Fill in fields -----%
            % Boom deployment time (orbits)
            if ~isempty(sat.boom)
                app.BoomdeploymenttimeorbitsEditField.Visible = true;
                if sim_Data.boom_deploy ~= -1
                    app.BoomdeploymenttimeorbitsEditField.Value = num2str((sim_Data.boom_deploy-1)*sim.dT/pOrb,'%.2f');
                else
                    app.BoomdeploymenttimeorbitsEditField.Value = 'N/A';
                end
            else
                app.BoomdeploymenttimeorbitsEditField.Visible = false;
            end
            
            % Orbital period (min)
            app.Orbitalperiod.Value = num2str(pOrb/60,'%.2f');
            
            
            if sim_Data.att_DT_time ~= -1
                % Max deviation from nadir after detumble (deg)
                max_dev = max(sim_Data.nadir(dt_ind:end))*180/pi;
                app.NadirDevMax.Value = num2str(max_dev,'%.2f');
            
                % Max deviation from north after detumble (deg)
                max_dev = max(sim_Data.north(dt_ind:end))*180/pi;
                app.NorthDevMax.Value = num2str(max_dev,'%.2f');
            
                % Percent of post-detumble time meeting requirements
                k = 0;
                j = 0;
                for i = dt_ind:length(t)
                    if sim_Data.nadir(i)*180/pi < app.nadir_pointing_req
                        k = k+1;
                    end
                    if sim_Data.north(i)*180/pi < app.north_pointing_req
                        j = j+1;
                    end
                end
                nadir_pct = k/(length(t)-dt_ind+1)*100;
                app.NadirPctMet.Value = num2str(nadir_pct,'%.2f');
                north_pct = j/(length(t)-dt_ind+1)*100;
                app.NorthPctMet.Value = num2str(north_pct,'%.2f');
            
                % Latitude below which pointing requirement percentage is met
                % TO DO %
                
            else
                app.NadirDevMax.Value = 'N/A';
                app.NorthDevMax.Value = 'N/A';
                app.NadirPctMet.Value = 'N/A';
                app.NorthPctMet.Value = 'N/A';
            end
            
            % Fourier transforms
            fourier_data = [sim_Data.fourier.p_roll*180/pi; sim_Data.fourier.p_pitch*180/pi; sim_Data.fourier.p_yaw*180/pi];
            f_axes = [app.Roll_F app.Pitch_F app.Yaw_F];
            PlotApp(f_axes,sim_Data.fourier.f,fourier_data);
            
            %-------------------- Attitude determination tab --------------------%
            % Nominal angle to horizon
            nominal_elev = acos(app.rE/app.el(1))*180/pi;
            app.HorizonAngle.Value = num2str(nominal_elev,'%.2f');
            
            %----- Earth in Z axis optical boresight -----%
            z_boresight         = zeros(1,length(t));
            z_boresight_sun     = zeros(1,length(t));
            z_boresight_moon    = zeros(1,length(t));
            sun_marker_indices  = [];
            moon_marker_indices = [];
            nv_lvlh     = [0;0;1]; % Nadir vector in LVLH frame
            
            for i = 1:length(t)
                % Quaternion from LVLH frame to body frame
                qLVLHtoBody = sim_Data.qAnim(:,i);
                
                % Transform nadir vector to body frame
                nv_body = QForm(qLVLHtoBody,nv_lvlh);
                
                % Angle between nadir vector and body +Z direction
                del = acos(Dot(nv_body,[0;0;1])/(norm(nv_body)))*180/pi;
                
                % Angle between sun vector and body +Z direction
                del_sun = acos(Dot(sim_Data.uSunBody(:,i),[0;0;1]))*180/pi;
                
                % Moon unit vector in body frame, and angle between moon
                % vector and body +Z direction
                moon_u_ECI  = MoonV1(sim.jD0+t(i)/86400,x(1:3,i));
                qECItoBody  = x(7:10,i);
                moon_u_body = QForm(qECItoBody, moon_u_ECI);
                del_moon    = acos(Dot(moon_u_body,[0;0;1]))*180/pi;
                
                % Apparent angular size of Earth
                h   = sim_Data.lla(3,i);
                rho = asin(app.rE/(app.rE+h))*180/pi;
                
                % Check if Earth lies within the FOV of the IR sensor
                if del < (rho + sim.AD.half_angle)
                    z_boresight(i) = 1;
                end
                
                % Check if the Sun lies within the FOV of the IR sensor
                rho_sun = 0.53; % Apparent angular size of sun from Earth (deg)
                if del_sun < (rho_sun + sim.AD.half_angle)
                    z_boresight_sun(i) = 1;
                    sun_marker_indices = [sun_marker_indices, i];
                end
                
                % Check if the Moon lies within the FOV of the IR sensor
                rho_moon = 0.52; % Apparent angular size of moon from Earth (deg)
                if del_moon < (rho_moon + sim.AD.half_angle)
                    z_boresight_moon(i) = 1;
                    moon_marker_indices = [moon_marker_indices, i];
                end
            end
            
            p = plot(app.ZAxisBoresight,t(1:end)/pOrb,z_boresight,'k', ...
                t(1:end)/pOrb,z_boresight_sun,':or', ...
                t(1:end)/pOrb,z_boresight_moon,':ob');
            p(2).MarkerIndices = sun_marker_indices;
            p(3).MarkerIndices = moon_marker_indices;
            
            %----- IR sensors on +/- X/Y faces -----%
            elv     = sim.AD.elevation*pi/180; % Sensor elevation (rad)
            z_comp  = sin(elv);
            xy_comp = cos(elv);
            % Unit vectors of sensors
            % [+X down/up, -X down/up, +Y down/up, -Y down/up]
            u_body = [[xy_comp;0;z_comp],[xy_comp;0;-z_comp], ...
                [-xy_comp;0;z_comp],[-xy_comp;0;-z_comp], ...
                [0;xy_comp;z_comp],[0;xy_comp;-z_comp], ...
                [0;-xy_comp;z_comp],[0;-xy_comp;-z_comp]];
            
            AD_boresights       = zeros(8,length(t));
            AD_boresights_sun   = zeros(8,length(t));
            AD_sun_indices1      = [];
            AD_sun_indices2      = [];
            AD_sun_indices3      = [];
            AD_sun_indices4      = [];
            AD_sun_indices5      = [];
            AD_sun_indices6      = [];
            AD_sun_indices7      = [];
            AD_sun_indices8      = [];
            AD_boresights_moon  = zeros(8,length(t));
            AD_moon_indices1     = [];
            AD_moon_indices2     = [];
            AD_moon_indices3     = [];
            AD_moon_indices4     = [];
            AD_moon_indices5     = [];
            AD_moon_indices6     = [];
            AD_moon_indices7     = [];
            AD_moon_indices8     = [];
            
            
            for i = 1:length(t)
                % Quaternion from LVLH frame to body frame
                qLVLHtoBody = sim_Data.qAnim(:,i);
                
                % Apparent angular size of Earth
                h   = sim_Data.lla(3,i);
                rho = asin(app.rE/(app.rE+h))*180/pi;
                
                threshold = rho + sim.AD.half_angle;
                
                % Moon vector
                moon_u_ECI  = MoonV1(sim.jD0+t(i)/86400,x(1:3,i));
                qECItoBody  = x(7:10,i);
                moon_u_body = QForm(qECItoBody, moon_u_ECI);
                
                for j = 1:8
                    % Nadir vector in body frame
                    nv_body = QForm(qLVLHtoBody,[0;0;1]);
                    
                    % Angle between unit vector and nadir
                    del = acos(Dot(u_body(:,j),nv_body)/norm(nv_body))*180/pi;
                    
                    % Angle between unit vector and sun vector
                    del_sun = acos(Dot(sim_Data.uSunBody(:,i),u_body(:,j)))*180/pi;
                    rho_sun = 0.53;
                    
                    % Angle between unit vector and moon vector
                    del_moon = acos(Dot(moon_u_body,u_body(:,j)))*180/pi;
                    rho_moon = 0.52;
                    
                    if del < threshold
                        AD_boresights(j,i) = 1;
                    end
                    
                    if del_sun < rho_sun + sim.AD.half_angle && AD_boresights(j,i) ~= 1
                        AD_boresights_sun(j,i) = 1;
                        switch j
                            case 1
                                AD_sun_indices1      = [AD_sun_indices1 i];
                            case 2
                                AD_sun_indices2      = [AD_sun_indices2 i];
                            case 3
                                AD_sun_indices3      = [AD_sun_indices3 i];
                            case 4
                                AD_sun_indices4      = [AD_sun_indices4 i];
                            case 5
                                AD_sun_indices5      = [AD_sun_indices5 i];
                            case 6
                                AD_sun_indices6      = [AD_sun_indices6 i];
                            case 7
                                AD_sun_indices7      = [AD_sun_indices7 i];
                            case 8
                                AD_sun_indices8      = [AD_sun_indices8 i];
                        end
                    end
                    
                    if del_moon < rho_moon + sim.AD.half_angle && AD_boresights(j,i) ~= 1
                        AD_boresights_moon(j,i) = 1;
                        switch j
                            case 1
                                AD_moon_indices1     = [AD_moon_indices1 i];
                            case 2
                                AD_moon_indices2     = [AD_moon_indices2 i];
                            case 3
                                AD_moon_indices3     = [AD_moon_indices3 i];
                            case 4
                                AD_moon_indices4     = [AD_moon_indices4 i];
                            case 5
                                AD_moon_indices5     = [AD_moon_indices5 i];
                            case 6
                                AD_moon_indices6     = [AD_moon_indices6 i];
                            case 7
                                AD_moon_indices7     = [AD_moon_indices7 i];
                            case 8
                                AD_moon_indices8     = [AD_moon_indices8 i];
                        end
                    end
                    
                end
            end

            
            % Plot to axes: [+X down/up, -X down/up, +Y down/up, -Y down/up]
            % +X down/up
            pXplus = plot(app.PlusXBoresights,t(1:end)/pOrb,AD_boresights(1,:),'k', ...
                 t(1:end)/pOrb,AD_boresights(2,:),'b', ...
                t(1:end)/pOrb,AD_boresights_sun(1,:),':or', ...
                t(1:end)/pOrb,AD_boresights_sun(2,:),':om', ...
                t(1:end)/pOrb,AD_boresights_moon(1,:),':og', ...
                t(1:end)/pOrb,AD_boresights_moon(2,:),':oc');
            
            pXplus(3).MarkerIndices = AD_sun_indices1;
            pXplus(4).MarkerIndices = AD_sun_indices2;
            pXplus(5).MarkerIndices = AD_moon_indices1;
            pXplus(6).MarkerIndices = AD_moon_indices2;
            
            % -X down/up
            pXminus = plot(app.MinusXBoresights,t(1:end)/pOrb,AD_boresights(3,:),'k', ...
                 t(1:end)/pOrb,AD_boresights(4,:),'b', ...
                t(1:end)/pOrb,AD_boresights_sun(3,:),':or', ...
                t(1:end)/pOrb,AD_boresights_sun(4,:),':om', ...
                t(1:end)/pOrb,AD_boresights_moon(3,:),':og', ...
                t(1:end)/pOrb,AD_boresights_moon(4,:),':oc');
            
            pXminus(3).MarkerIndices = AD_sun_indices3;
            pXminus(4).MarkerIndices = AD_sun_indices4;
            pXminus(5).MarkerIndices = AD_moon_indices3;
            pXminus(6).MarkerIndices = AD_moon_indices4;
            
            % +Y down/up
            pYplus = plot(app.PlusYBoresights,t(1:end)/pOrb,AD_boresights(5,:),'k', ...
                 t(1:end)/pOrb,AD_boresights(6,:),'b', ...
                t(1:end)/pOrb,AD_boresights_sun(5,:),':or', ...
                t(1:end)/pOrb,AD_boresights_sun(6,:),':om', ...
                t(1:end)/pOrb,AD_boresights_moon(5,:),':og', ...
                t(1:end)/pOrb,AD_boresights_moon(6,:),':oc');
            
            pYplus(3).MarkerIndices = AD_sun_indices5;
            pYplus(4).MarkerIndices = AD_sun_indices6;
            pYplus(5).MarkerIndices = AD_moon_indices5;
            pYplus(6).MarkerIndices = AD_moon_indices6;
            
            % -Y down/up
            pYminus = plot(app.MinusYBoresights,t(1:end)/pOrb,AD_boresights(7,:),'k', ...
                 t(1:end)/pOrb,AD_boresights(8,:),'b', ...
                t(1:end)/pOrb,AD_boresights_sun(7,:),':or', ...
                t(1:end)/pOrb,AD_boresights_sun(8,:),':om', ...
                t(1:end)/pOrb,AD_boresights_moon(7,:),':og', ...
                t(1:end)/pOrb,AD_boresights_moon(8,:),':oc');
            
            pYminus(3).MarkerIndices = AD_sun_indices7;
            pYminus(4).MarkerIndices = AD_sun_indices8;
            pYminus(5).MarkerIndices = AD_moon_indices7;
            pYminus(6).MarkerIndices = AD_moon_indices8;
            
            
            %---------- Numerical integration of IMU data ----------%
            [q_r, eul_r, nd_r, t_int] = IntegrateIMU( x, t, sim, sim_Data );
            
            imu_ax = [app.Roll_IMU app.Pitch_IMU app.Yaw_IMU];
            for i = 1:3
                plot(imu_ax(i), t_int/pOrb, eul_r(i,:)*180/pi, t/pOrb, sim_Data.eul(i,:)*180/pi,':k');
                grid(imu_ax(i),'on');
            end
            
            nd_ax = app.Nadir_Reconstruction;
            plot(nd_ax, t_int/pOrb, nd_r*180/pi, t/pOrb, sim_Data.nadir*180/pi,':k');
            grid(nd_ax,'on');
            legend(nd_ax,'Reconstructed','Simulated');
        end

        % Button pushed function: DisplayGroundTrackButton
        function DisplayGroundTrackButtonPushed(app, event)
            if ~isempty(app.xOut)
                GroundTrack(app.xOut(1:3,:), app.tPlot, app.simulation.jD0);
            end
        end

        % Button pushed function: Display3DOrbitButton
        function Display3DOrbitButtonPushed(app, event)
            if ~isempty(app.xOut)
                PlotOrbit(app.xOut(1:3,:), app.tPlot, app.simulation.jD0);
            end
        end

        % Button pushed function: DisplayAttitudeAnimationButton
        function DisplayAttitudeAnimationButtonPushed(app, event)
            if ~isempty(app.xOut)
                AnimQ(app.simData.qAnim, app.speed_factor);
            end
        end

        % Value changed function: ComputeAerodynamicsKnob
        function ComputeAerodynamicsKnobValueChanged(app, event)
            value = app.ComputeAerodynamicsKnob.Value;
            
            if strcmp(value, 'Never')
                app.aero_calc = 1;
            elseif strcmp(value, 'After Boom Deployment')
                app.aero_calc = 2;
            elseif strcmp(value, 'Always')
                app.aero_calc = 3;
            end
        end

        % Value changed function: Speedfactor0to100EditField
        function Speedfactor0to100EditFieldValueChanged(app, event)
            value = app.Speedfactor0to100EditField.Value;
            app.speed_factor = value;
        end

        % Button pushed function: SaveButton
        function SaveButtonPushed(app, event)
            % Save simulation run to a .mat file
            filename = app.FileNameEditField_2.Value;
            
            if ~strcmp(filename(end-3:end),'.mat')
                filename = strcat(filename,'.mat');
            end
            
            sat = app.satellite;
            sim = app.simulation;
            x = app.xOut;
            t = app.tPlot;
            sim_Data = app.simData;
            
            save(filename,'sat','sim','x','t','sim_Data');
        end

        % Button pushed function: LoadButton
        function LoadButtonPushed(app, event)
            filename = app.FileNameEditField.Value;
            
            files = dir(filename);
            
            % Check if there are no simulation files to load from
            if isempty(files)
                message = 'No such file in working directory.';
                alert(app,message);
            else
                % Load the following variables: sat, sim, x, t, sim_Data
                vars = load(files(end).name);
                % Make accessible outside this function
                app.xOut        = vars.x;
                app.tPlot       = vars.t;
                app.simData     = vars.sim_Data;
                app.satellite   = vars.sat;
                app.simulation  = vars.sim;
                
                x = vars.x;
                t = vars.t;
                sim_Data = vars.sim_Data;
                sat = vars.sat;
                sim = vars.sim;
                
                % Make 'Save' button visible
                app.SaveButton.Visible = true;
                
                % If certain conditions were not met, throw a warning
                warning = "";
                if sim_Data.att_DT_time == -1
                    warning = "ERROR: The attitude detumble condition was never met." + newline;
                end
                if app.active_system && sim_Data.torquerod_time(1) == -1
                    warning = warning + "ERROR: Torque rod condition to turn on was never met." + newline;
                end
                if app.active_system && sim_Data.torquerod_time(2) == -1
                    warning = warning + "ERROR: Torque rod condition to turn off was never met." + newline;
                end
                if app.gravity_boom
                    if sim_Data.boom_deploy == -1
                        warning = warning + "ERROR: The gravity boom deployment condition was never met.";
                    end
                end
                
                if strcmp(warning,"")
                    fig = app.CubeSatADSSDesignandSimulationUIFigure;
                    message = 'SUCCESS: Simulation proceeded as expected.';
                    uialert(fig,message,'Simulation Complete','Icon','success');
                else
                    fig = app.CubeSatADSSDesignandSimulationUIFigure;
                    uialert(fig,warning,'Warning','Icon','error');
                end
                
                
                %-------------------- Plot data to axes --------------------%
                pOrb = sim_Data.pOrb;
                app.CubeSatADSSDesignandSimulationUIFigure.AutoResizeChildren = 'off';
                
                % Orbit information
                orb_axes = [app.OrbitX app.OrbitY app.OrbitZ];
                PlotApp(orb_axes, t/pOrb, sim_Data.lla);
                
                %----- Disturbance torques -----%
                mag_axes = [app.MagTorqueX app.MagTorqueY app.MagTorqueZ];
                PlotApp(mag_axes, t/pOrb, sim_Data.dist.tMag);
                
                hyst_axes = [app.HystTorqueX app.HystTorqueY app.HystTorqueZ];
                PlotApp(hyst_axes, t/pOrb, sim_Data.dist.tHyst);
                
                gg_axes = [app.GGTorqueX app.GGTorqueY app.GGTorqueZ];
                PlotApp(gg_axes, t/pOrb, sim_Data.dist.tGG);
                
                aero_axes = [app.AeroTorqueX app.AeroTorqueY app.AeroTorqueZ];
                PlotApp(aero_axes, t/pOrb, sim_Data.dist.tAero);
                
                opt_axes = [app.OptTorqueX app.OptTorqueY app.OptTorqueZ];
                PlotApp(opt_axes, t/pOrb, sim_Data.dist.tOpt);
                
                %----- Magnetic field -----%
                bbody_axes = [app.Bx_body app.By_body app.Bz_body];
                PlotApp(bbody_axes, t/pOrb, sim_Data.bFieldBody);
                
                blvlh_axes = [app.Bx_LVLH app.By_LVLH app.Bz_LVLH];
                PlotApp(blvlh_axes, t/pOrb, sim_Data.bFieldLVLH);
                
                
                %----- Detumble times -----%
                if sim_Data.att_DT_time ~= -1
                    att_detumble_sec = (sim_Data.att_DT_time - 1) * sim.dT;
                    att_detumble_orb = att_detumble_sec / pOrb;
                    att_detumble_day = att_detumble_sec / 86400;
                
                    app.TimeuntilattitudedetumbleorbitsEditField.Value = num2str(att_detumble_orb,'%.2f');
                    app.TimeuntilattitudedetumbledaysEditField.Value = num2str(att_detumble_day,'%.2f');
                    
                else % the attitude detumble condition was never reached
                    app.TimeuntilattitudedetumbleorbitsEditField.Value = 'N/A';
                    app.TimeuntilattitudedetumbledaysEditField.Value = 'N/A';
                end
                
                if sim_Data.radio_DT_time ~= -1
                    radio_detumble_sec = (sim_Data.radio_DT_time - 1) * sim.dT;
                    radio_detumble_orb = radio_detumble_sec / pOrb;
                    radio_detumble_day = radio_detumble_sec / 86400;
                
                    app.TimeuntilradiodetumbleorbitsEditField.Value = num2str(radio_detumble_orb,'%.2f');
                    app.TimeuntilradiodetumbledaysEditField.Value = num2str(radio_detumble_day,'%.2f');
                    
                else % the radio detumble condition was never reached
                    app.TimeuntilradiodetumbleorbitsEditField.Value = 'N/A';
                    app.TimeuntilradiodetumbledaysEditField.Value = 'N/A'; 
                end
                
                % Hysteresis loop sample
                if ~isempty(sim_Data.dist.rodH)
                    app.HystAxes.Visible = true;
                    PlotApp(app.HystAxes, sim_Data.dist.rodH(1,:), x(15,:));
                else
                    app.HystAxes.Visible = false;
                end
                
                %----- Attitude rates during detumble -----%
                dt_axes = [app.roll_rate_detumble app.pitch_rate_detumble app.yaw_rate_detumble];
                if sim_Data.att_DT_time == -1 % the attitude detumble condition was never reached; plot all data
                    PlotApp(dt_axes, t/pOrb, x(11:13,:)*180/pi);
                    
                elseif sim_Data.att_DT_time ~= 1 % attitude detumble condition is not met initially
                    dt_ind = sim_Data.att_DT_time;
                    PlotApp(dt_axes, t(1:dt_ind)/pOrb, x(11:13,1:dt_ind)*180/pi);
                    
                end
                
                %------ Attitude rates post-detumble ------%
                if sim_Data.att_DT_time ~= -1 % the attitude detumble condition was reached at some point
                    dt_ind = sim_Data.att_DT_time;
                    
                    eul_ax  = [app.Roll app.Pitch app.Yaw];
                    rate_ax = [app.roll_rate app.pitch_rate app.yaw_rate];
                    acc_ax  = [app.roll_acc app.pitch_acc app.yaw_acc];
                    
                    PlotApp(eul_ax, t(dt_ind:end)/pOrb, sim_Data.eul(:,dt_ind:end)*180/pi);
                    PlotApp(rate_ax, t(dt_ind:end)/pOrb, x(11:13,dt_ind:end)*180/pi);
                    PlotApp(acc_ax, t(dt_ind:end)/pOrb, sim_Data.alpha(:,dt_ind:end)*180/pi);
                else
                    dt_ind = length(t);
                end
                
                %-------------- Pointing tab --------------%
                % Plot pointing errors
                if sim_Data.att_DT_time ~= -1 % the attitude detumble condition was reached at some point
                    dt_ind = sim_Data.att_DT_time;
                    
                    nadir_data = [sim_Data.nadir(dt_ind:end)*180/pi; app.nadir_pointing_req*ones(1,length(t)-dt_ind+1)];
                    PlotApp(app.NadirAxes, t(dt_ind:end)/pOrb,nadir_data);
                    
                    north_data = [sim_Data.north(dt_ind:end)*180/pi; app.north_pointing_req*ones(1,length(t)-dt_ind+1)];
                    PlotApp(app.NorthAxes, t(dt_ind:end)/pOrb, north_data);
                    
                    if ~isempty(sat.boom) 
                        if sim_Data.boom_deploy >= sim_Data.att_DT_time
                            xline(app.NadirAxes,t(sim_Data.boom_deploy)/pOrb,'-','Boom Deployment');
                            grid(app.NadirAxes,'on');
                            
                            xline(app.NorthAxes,t(sim_Data.boom_deploy)/pOrb,'-','Boom Deployment');
                            grid(app.NorthAxes,'on');
                        end
                    end
                    
                    
                else
                    app.NadirAxes.Visible = false;
                    app.NorthAxes.Visible = false;
                end
                
                %----- Fill in fields -----%
                % Boom deployment time (orbits)
                if ~isempty(sat.boom)
                    app.BoomdeploymenttimeorbitsEditField.Visible = true;
                    if sim_Data.boom_deploy ~= -1
                        app.BoomdeploymenttimeorbitsEditField.Value = num2str((sim_Data.boom_deploy-1)*sim.dT/pOrb,'%.2f');
                    else
                        app.BoomdeploymenttimeorbitsEditField.Value = 'N/A';
                    end
                else
                    app.BoomdeploymenttimeorbitsEditField.Visible = false;
                end
                
                % Orbital period (min)
                app.Orbitalperiod.Value = num2str(pOrb/60,'%.2f');
                
                
                if sim_Data.att_DT_time ~= -1
                    % Max deviation from nadir after detumble (deg)
                    max_dev = max(sim_Data.nadir(dt_ind:end))*180/pi;
                    app.NadirDevMax.Value = num2str(max_dev,'%.2f');
                
                    % Max deviation from north after detumble (deg)
                    max_dev = max(sim_Data.north(dt_ind:end))*180/pi;
                    app.NorthDevMax.Value = num2str(max_dev,'%.2f');
                
                    % Percent of post-detumble time meeting requirements
                    k = 0;
                    j = 0;
                    for i = dt_ind:length(t)
                        if sim_Data.nadir(i)*180/pi < app.nadir_pointing_req
                            k = k+1;
                        end
                        if sim_Data.north(i)*180/pi < app.north_pointing_req
                            j = j+1;
                        end
                    end
                    nadir_pct = k/(length(t)-dt_ind+1)*100;
                    app.NadirPctMet.Value = num2str(nadir_pct,'%.2f');
                    north_pct = j/(length(t)-dt_ind+1)*100;
                    app.NorthPctMet.Value = num2str(north_pct,'%.2f');
                
                    % Latitude below which pointing requirement percentage is met
                    % TO DO %
                    
                else
                    app.NadirDevMax.Value = 'N/A';
                    app.NorthDevMax.Value = 'N/A';
                    app.NadirPctMet.Value = 'N/A';
                    app.NorthPctMet.Value = 'N/A';
                end
                
                % Fourier transforms
                fourier_data = [sim_Data.fourier.p_roll*180/pi; sim_Data.fourier.p_pitch*180/pi; sim_Data.fourier.p_yaw*180/pi];
                f_axes = [app.Roll_F app.Pitch_F app.Yaw_F];
                PlotApp(f_axes,sim_Data.fourier.f,fourier_data);
                
                %-------------------- Attitude determination tab --------------------%
                % Nominal angle to horizon
                nominal_elev = acos(app.rE/app.el(1))*180/pi;
                app.HorizonAngle.Value = num2str(nominal_elev,'%.2f');
                
                %----- Earth in Z axis optical boresight -----%
                z_boresight         = zeros(1,length(t));
                z_boresight_sun     = zeros(1,length(t));
                z_boresight_moon    = zeros(1,length(t));
                sun_marker_indices  = [];
                moon_marker_indices = [];
                nv_lvlh     = [0;0;1]; % Nadir vector in LVLH frame
                
                for i = 1:length(t)
                    % Quaternion from LVLH frame to body frame
                    qLVLHtoBody = sim_Data.qAnim(:,i);
                    
                    % Transform nadir vector to body frame
                    nv_body = QForm(qLVLHtoBody,nv_lvlh);
                    
                    % Angle between nadir vector and body +Z direction
                    del = acos(Dot(nv_body,[0;0;1])/(norm(nv_body)))*180/pi;
                    
                    % Angle between sun vector and body +Z direction
                    del_sun = acos(Dot(sim_Data.uSunBody(:,i),[0;0;1]))*180/pi;
                    
                    % Moon unit vector in body frame, and angle between moon
                    % vector and body +Z direction
                    moon_u_ECI  = MoonV1(sim.jD0+t(i)/86400,x(1:3,i));
                    qECItoBody  = x(7:10,i);
                    moon_u_body = QForm(qECItoBody, moon_u_ECI);
                    del_moon    = acos(Dot(moon_u_body,[0;0;1]))*180/pi;
                    
                    % Apparent angular size of Earth
                    h   = sim_Data.lla(3,i);
                    rho = asin(app.rE/(app.rE+h))*180/pi;
                    
                    % Check if Earth lies within the FOV of the IR sensor
                    if del < (rho + sim.AD.half_angle)
                        z_boresight(i) = 1;
                    end
                    
                    % Check if the Sun lies within the FOV of the IR sensor
                    rho_sun = 0.53; % Apparent angular size of sun from Earth (deg)
                    if del_sun < (rho_sun + sim.AD.half_angle)
                        z_boresight_sun(i) = 1;
                        sun_marker_indices = [sun_marker_indices, i];
                    end
                    
                    % Check if the Moon lies within the FOV of the IR sensor
                    rho_moon = 0.52; % Apparent angular size of moon from Earth (deg)
                    if del_moon < (rho_moon + sim.AD.half_angle)
                        z_boresight_moon(i) = 1;
                        moon_marker_indices = [moon_marker_indices, i];
                    end
                end
                
                p = plot(app.ZAxisBoresight,t(1:end)/pOrb,z_boresight,'k', ...
                    t(1:end)/pOrb,z_boresight_sun,':or', ...
                    t(1:end)/pOrb,z_boresight_moon,':ob');
                p(2).MarkerIndices = sun_marker_indices;
                p(3).MarkerIndices = moon_marker_indices;
                
                %----- IR sensors on +/- X/Y faces -----%
                elv     = sim.AD.elevation*pi/180; % Sensor elevation (rad)
                z_comp  = sin(elv);
                xy_comp = cos(elv);
                % Unit vectors of sensors
                % [+X down/up, -X down/up, +Y down/up, -Y down/up]
                u_body = [[xy_comp;0;z_comp],[xy_comp;0;-z_comp], ...
                    [-xy_comp;0;z_comp],[-xy_comp;0;-z_comp], ...
                    [0;xy_comp;z_comp],[0;xy_comp;-z_comp], ...
                    [0;-xy_comp;z_comp],[0;-xy_comp;-z_comp]];
                
                AD_boresights       = zeros(8,length(t));
                AD_boresights_sun   = zeros(8,length(t));
                AD_sun_indices1      = [];
                AD_sun_indices2      = [];
                AD_sun_indices3      = [];
                AD_sun_indices4      = [];
                AD_sun_indices5      = [];
                AD_sun_indices6      = [];
                AD_sun_indices7      = [];
                AD_sun_indices8      = [];
                AD_boresights_moon  = zeros(8,length(t));
                AD_moon_indices1     = [];
                AD_moon_indices2     = [];
                AD_moon_indices3     = [];
                AD_moon_indices4     = [];
                AD_moon_indices5     = [];
                AD_moon_indices6     = [];
                AD_moon_indices7     = [];
                AD_moon_indices8     = [];
                
                
                for i = 1:length(t)
                    % Quaternion from LVLH frame to body frame
                    qLVLHtoBody = sim_Data.qAnim(:,i);
                    
                    % Apparent angular size of Earth
                    h   = sim_Data.lla(3,i);
                    rho = asin(app.rE/(app.rE+h))*180/pi;
                    
                    threshold = rho + sim.AD.half_angle;
                    
                    % Moon vector
                    moon_u_ECI  = MoonV1(sim.jD0+t(i)/86400,x(1:3,i));
                    qECItoBody  = x(7:10,i);
                    moon_u_body = QForm(qECItoBody, moon_u_ECI);
                    
                    for j = 1:8
                        % Nadir vector in body frame
                        nv_body = QForm(qLVLHtoBody,[0;0;1]);
                        
                        % Angle between unit vector and nadir
                        del = acos(Dot(u_body(:,j),nv_body)/norm(nv_body))*180/pi;
                        
                        % Angle between unit vector and sun vector
                        del_sun = acos(Dot(sim_Data.uSunBody(:,i),u_body(:,j)))*180/pi;
                        rho_sun = 0.53;
                        
                        % Angle between unit vector and moon vector
                        del_moon = acos(Dot(moon_u_body,u_body(:,j)))*180/pi;
                        rho_moon = 0.52;
                        
                        if del < threshold
                            AD_boresights(j,i) = 1;
                        end
                        
                        if del_sun < rho_sun + sim.AD.half_angle && AD_boresights(j,i) ~= 1
                            AD_boresights_sun(j,i) = 1;
                            switch j
                                case 1
                                    AD_sun_indices1      = [AD_sun_indices1 i];
                                case 2
                                    AD_sun_indices2      = [AD_sun_indices2 i];
                                case 3
                                    AD_sun_indices3      = [AD_sun_indices3 i];
                                case 4
                                    AD_sun_indices4      = [AD_sun_indices4 i];
                                case 5
                                    AD_sun_indices5      = [AD_sun_indices5 i];
                                case 6
                                    AD_sun_indices6      = [AD_sun_indices6 i];
                                case 7
                                    AD_sun_indices7      = [AD_sun_indices7 i];
                                case 8
                                    AD_sun_indices8      = [AD_sun_indices8 i];
                            end
                        end
                        
                        if del_moon < rho_moon + sim.AD.half_angle && AD_boresights(j,i) ~= 1
                            AD_boresights_moon(j,i) = 1;
                            switch j
                                case 1
                                    AD_moon_indices1     = [AD_moon_indices1 i];
                                case 2
                                    AD_moon_indices2     = [AD_moon_indices2 i];
                                case 3
                                    AD_moon_indices3     = [AD_moon_indices3 i];
                                case 4
                                    AD_moon_indices4     = [AD_moon_indices4 i];
                                case 5
                                    AD_moon_indices5     = [AD_moon_indices5 i];
                                case 6
                                    AD_moon_indices6     = [AD_moon_indices6 i];
                                case 7
                                    AD_moon_indices7     = [AD_moon_indices7 i];
                                case 8
                                    AD_moon_indices8     = [AD_moon_indices8 i];
                            end
                        end
                        
                    end
                end
    
                
                % Plot to axes: [+X down/up, -X down/up, +Y down/up, -Y down/up]
                % +X down/up
                pXplus = plot(app.PlusXBoresights,t(1:end)/pOrb,AD_boresights(1,:),'k', ...
                     t(1:end)/pOrb,AD_boresights(2,:),'b', ...
                    t(1:end)/pOrb,AD_boresights_sun(1,:),':or', ...
                    t(1:end)/pOrb,AD_boresights_sun(2,:),':om', ...
                    t(1:end)/pOrb,AD_boresights_moon(1,:),':og', ...
                    t(1:end)/pOrb,AD_boresights_moon(2,:),':oc');
                
                pXplus(3).MarkerIndices = AD_sun_indices1;
                pXplus(4).MarkerIndices = AD_sun_indices2;
                pXplus(5).MarkerIndices = AD_moon_indices1;
                pXplus(6).MarkerIndices = AD_moon_indices2;
                
                % -X down/up
                pXminus = plot(app.MinusXBoresights,t(1:end)/pOrb,AD_boresights(3,:),'k', ...
                     t(1:end)/pOrb,AD_boresights(4,:),'b', ...
                    t(1:end)/pOrb,AD_boresights_sun(3,:),':or', ...
                    t(1:end)/pOrb,AD_boresights_sun(4,:),':om', ...
                    t(1:end)/pOrb,AD_boresights_moon(3,:),':og', ...
                    t(1:end)/pOrb,AD_boresights_moon(4,:),':oc');
                
                pXminus(3).MarkerIndices = AD_sun_indices3;
                pXminus(4).MarkerIndices = AD_sun_indices4;
                pXminus(5).MarkerIndices = AD_moon_indices3;
                pXminus(6).MarkerIndices = AD_moon_indices4;
                
                % +Y down/up
                pYplus = plot(app.PlusYBoresights,t(1:end)/pOrb,AD_boresights(5,:),'k', ...
                     t(1:end)/pOrb,AD_boresights(6,:),'b', ...
                    t(1:end)/pOrb,AD_boresights_sun(5,:),':or', ...
                    t(1:end)/pOrb,AD_boresights_sun(6,:),':om', ...
                    t(1:end)/pOrb,AD_boresights_moon(5,:),':og', ...
                    t(1:end)/pOrb,AD_boresights_moon(6,:),':oc');
                
                pYplus(3).MarkerIndices = AD_sun_indices5;
                pYplus(4).MarkerIndices = AD_sun_indices6;
                pYplus(5).MarkerIndices = AD_moon_indices5;
                pYplus(6).MarkerIndices = AD_moon_indices6;
                
                % -Y down/up
                pYminus = plot(app.MinusYBoresights,t(1:end)/pOrb,AD_boresights(7,:),'k', ...
                     t(1:end)/pOrb,AD_boresights(8,:),'b', ...
                    t(1:end)/pOrb,AD_boresights_sun(7,:),':or', ...
                    t(1:end)/pOrb,AD_boresights_sun(8,:),':om', ...
                    t(1:end)/pOrb,AD_boresights_moon(7,:),':og', ...
                    t(1:end)/pOrb,AD_boresights_moon(8,:),':oc');
                
                pYminus(3).MarkerIndices = AD_sun_indices7;
                pYminus(4).MarkerIndices = AD_sun_indices8;
                pYminus(5).MarkerIndices = AD_moon_indices7;
                pYminus(6).MarkerIndices = AD_moon_indices8;
                
                
                %---------- Numerical integration of IMU data ----------%
                [q_r, eul_r, nd_r, t_int] = IntegrateIMU( x, t, sim, sim_Data );
                
                imu_ax = [app.Roll_IMU app.Pitch_IMU app.Yaw_IMU];
                for i = 1:3
                    plot(imu_ax(i), t_int/pOrb, eul_r(i,:)*180/pi, t/pOrb, sim_Data.eul(i,:)*180/pi,':k');
                    grid(imu_ax(i),'on');
                end
                
                nd_ax = app.Nadir_Reconstruction;
                plot(nd_ax, t_int/pOrb, nd_r*180/pi, t/pOrb, sim_Data.nadir*180/pi,':k');
                grid(nd_ax,'on');
                legend(nd_ax,'Reconstructed','Simulated');
            end 
        end

        % Value changed function: OrientationSwitch
        function OrientationSwitchValueChanged(app, event)
            value = app.OrientationSwitch.Value;
            if strcmp(value,'Zenith')
                app.boom_zenith = true;
            elseif strcmp(value,'Nadir')
                app.boom_zenith = false;
            end
        end

        % Value changed function: ADtriggerdurationminEditField
        function ADtriggerdurationminEditFieldValueChanged(app, event)
            value = app.ADtriggerdurationminEditField.Value;
            
            app.AD_trigger_duration = value;
        end

        % Value changed function: 
        % AttitudedetumbledurationminEditField
        function AttitudedetumbledurationminEditFieldValueChanged(app, event)
            value = app.AttitudedetumbledurationminEditField.Value;
            
            app.attitude_detumble_duration = value;
        end
    end

    % Component initialization
    methods (Access = private)

        % Create UIFigure and components
        function createComponents(app)

            % Create CubeSatADSSDesignandSimulationUIFigure and hide until all components are created
            app.CubeSatADSSDesignandSimulationUIFigure = uifigure('Visible', 'off');
            app.CubeSatADSSDesignandSimulationUIFigure.Position = [100 100 1200 700];
            app.CubeSatADSSDesignandSimulationUIFigure.Name = 'CubeSat ADSS Design and Simulation';

            % Create TabGroup
            app.TabGroup = uitabgroup(app.CubeSatADSSDesignandSimulationUIFigure);
            app.TabGroup.Position = [1 1 1200 700];

            % Create CubeSatInputsTab
            app.CubeSatInputsTab = uitab(app.TabGroup);
            app.CubeSatInputsTab.Title = 'CubeSat Inputs';

            % Create SizeandMassPropertiesPanel
            app.SizeandMassPropertiesPanel = uipanel(app.CubeSatInputsTab);
            app.SizeandMassPropertiesPanel.Title = 'Size and Mass Properties';
            app.SizeandMassPropertiesPanel.FontSize = 16;
            app.SizeandMassPropertiesPanel.Position = [70 410 293 187];

            % Create CenterofmasslocationmmPanel
            app.CenterofmasslocationmmPanel = uipanel(app.SizeandMassPropertiesPanel);
            app.CenterofmasslocationmmPanel.Title = 'Center of mass location (mm)';
            app.CenterofmasslocationmmPanel.Position = [61 13 186 51];

            % Create XLabel
            app.XLabel = uilabel(app.CenterofmasslocationmmPanel);
            app.XLabel.HorizontalAlignment = 'right';
            app.XLabel.Position = [1 5 18 22];
            app.XLabel.Text = 'X:';

            % Create XEditField
            app.XEditField = uieditfield(app.CenterofmasslocationmmPanel, 'numeric');
            app.XEditField.ValueChangedFcn = createCallbackFcn(app, @XEditFieldValueChanged, true);
            app.XEditField.Position = [26 5 32 22];

            % Create YEditFieldLabel
            app.YEditFieldLabel = uilabel(app.CenterofmasslocationmmPanel);
            app.YEditFieldLabel.HorizontalAlignment = 'right';
            app.YEditFieldLabel.Position = [52 5 25 22];
            app.YEditFieldLabel.Text = 'Y:';

            % Create YEditField
            app.YEditField = uieditfield(app.CenterofmasslocationmmPanel, 'numeric');
            app.YEditField.ValueChangedFcn = createCallbackFcn(app, @YEditFieldValueChanged, true);
            app.YEditField.Position = [84 5 32 22];

            % Create ZEditFieldLabel
            app.ZEditFieldLabel = uilabel(app.CenterofmasslocationmmPanel);
            app.ZEditFieldLabel.HorizontalAlignment = 'right';
            app.ZEditFieldLabel.Position = [115 5 25 22];
            app.ZEditFieldLabel.Text = 'Z:';

            % Create ZEditField
            app.ZEditField = uieditfield(app.CenterofmasslocationmmPanel, 'numeric');
            app.ZEditField.ValueChangedFcn = createCallbackFcn(app, @ZEditFieldValueChanged, true);
            app.ZEditField.Position = [147 5 32 22];

            % Create SizeLabel
            app.SizeLabel = uilabel(app.SizeandMassPropertiesPanel);
            app.SizeLabel.HorizontalAlignment = 'right';
            app.SizeLabel.Position = [78 128 31 22];
            app.SizeLabel.Text = 'Size:';

            % Create SizeDropDown
            app.SizeDropDown = uidropdown(app.SizeandMassPropertiesPanel);
            app.SizeDropDown.Items = {'1U', '1.5U', '2U', '3U'};
            app.SizeDropDown.ValueChangedFcn = createCallbackFcn(app, @SizeDropDownValueChanged, true);
            app.SizeDropDown.Position = [124 128 62 22];
            app.SizeDropDown.Value = '1U';

            % Create SatellitemassminusboomkgLabel
            app.SatellitemassminusboomkgLabel = uilabel(app.SizeandMassPropertiesPanel);
            app.SatellitemassminusboomkgLabel.HorizontalAlignment = 'right';
            app.SatellitemassminusboomkgLabel.Position = [15 85 182 22];
            app.SatellitemassminusboomkgLabel.Text = 'Satellite mass (minus boom) (kg):';

            % Create SatellitemassminusboomkgEditField
            app.SatellitemassminusboomkgEditField = uieditfield(app.SizeandMassPropertiesPanel, 'numeric');
            app.SatellitemassminusboomkgEditField.Limits = [0 Inf];
            app.SatellitemassminusboomkgEditField.ValueDisplayFormat = '%11.2f';
            app.SatellitemassminusboomkgEditField.ValueChangedFcn = createCallbackFcn(app, @SatellitemassminusboomkgEditFieldValueChanged, true);
            app.SatellitemassminusboomkgEditField.Position = [212 85 64 22];
            app.SatellitemassminusboomkgEditField.Value = 1.5;

            % Create PassiveMagneticComponentsPanel
            app.PassiveMagneticComponentsPanel = uipanel(app.CubeSatInputsTab);
            app.PassiveMagneticComponentsPanel.Title = 'Passive Magnetic Components';
            app.PassiveMagneticComponentsPanel.FontSize = 16;
            app.PassiveMagneticComponentsPanel.Position = [70 203 293 174];

            % Create PermanentdipoleATM2Panel
            app.PermanentdipoleATM2Panel = uipanel(app.PassiveMagneticComponentsPanel);
            app.PermanentdipoleATM2Panel.Title = 'Permanent dipole (ATM^2)';
            app.PermanentdipoleATM2Panel.Position = [37 89 219 51];

            % Create XEditField_2Label
            app.XEditField_2Label = uilabel(app.PermanentdipoleATM2Panel);
            app.XEditField_2Label.HorizontalAlignment = 'right';
            app.XEditField_2Label.Position = [1 5 18 22];
            app.XEditField_2Label.Text = 'X:';

            % Create XEditField_2
            app.XEditField_2 = uieditfield(app.PermanentdipoleATM2Panel, 'numeric');
            app.XEditField_2.ValueChangedFcn = createCallbackFcn(app, @XEditField_2ValueChanged, true);
            app.XEditField_2.Position = [26 5 44 22];

            % Create YEditField_2Label
            app.YEditField_2Label = uilabel(app.PermanentdipoleATM2Panel);
            app.YEditField_2Label.HorizontalAlignment = 'right';
            app.YEditField_2Label.Position = [64 5 20 22];
            app.YEditField_2Label.Text = 'Y:';

            % Create YEditField_2
            app.YEditField_2 = uieditfield(app.PermanentdipoleATM2Panel, 'numeric');
            app.YEditField_2.ValueChangedFcn = createCallbackFcn(app, @YEditField_2ValueChanged, true);
            app.YEditField_2.Position = [92 5 49 22];

            % Create ZEditField_2Label
            app.ZEditField_2Label = uilabel(app.PermanentdipoleATM2Panel);
            app.ZEditField_2Label.HorizontalAlignment = 'right';
            app.ZEditField_2Label.Position = [140 5 17 22];
            app.ZEditField_2Label.Text = 'Z:';

            % Create ZEditField_2
            app.ZEditField_2 = uieditfield(app.PermanentdipoleATM2Panel, 'numeric');
            app.ZEditField_2.ValueChangedFcn = createCallbackFcn(app, @ZEditField_2ValueChanged, true);
            app.ZEditField_2.Position = [165 5 46 22];

            % Create HysteresisrodpairsSpinnerLabel
            app.HysteresisrodpairsSpinnerLabel = uilabel(app.PassiveMagneticComponentsPanel);
            app.HysteresisrodpairsSpinnerLabel.HorizontalAlignment = 'right';
            app.HysteresisrodpairsSpinnerLabel.Position = [58 52 122 22];
            app.HysteresisrodpairsSpinnerLabel.Text = 'Hysteresis rod pairs:';

            % Create HysteresisrodpairsSpinner
            app.HysteresisrodpairsSpinner = uispinner(app.PassiveMagneticComponentsPanel);
            app.HysteresisrodpairsSpinner.Limits = [0 10];
            app.HysteresisrodpairsSpinner.ValueChangedFcn = createCallbackFcn(app, @HysteresisrodpairsSpinnerValueChanged, true);
            app.HysteresisrodpairsSpinner.Editable = 'off';
            app.HysteresisrodpairsSpinner.Position = [189 52 46 22];

            % Create RodaxesDropDownLabel
            app.RodaxesDropDownLabel = uilabel(app.PassiveMagneticComponentsPanel);
            app.RodaxesDropDownLabel.HorizontalAlignment = 'right';
            app.RodaxesDropDownLabel.Visible = 'off';
            app.RodaxesDropDownLabel.Position = [61 22 59 22];
            app.RodaxesDropDownLabel.Text = 'Rod axes:';

            % Create RodaxesDropDown
            app.RodaxesDropDown = uidropdown(app.PassiveMagneticComponentsPanel);
            app.RodaxesDropDown.Items = {'X and Y', 'X and Z', 'Y and Z'};
            app.RodaxesDropDown.ValueChangedFcn = createCallbackFcn(app, @RodaxesDropDownValueChanged, true);
            app.RodaxesDropDown.Visible = 'off';
            app.RodaxesDropDown.Position = [135 22 100 22];
            app.RodaxesDropDown.Value = 'X and Y';

            % Create GravityBoomPanel
            app.GravityBoomPanel = uipanel(app.CubeSatInputsTab);
            app.GravityBoomPanel.Title = 'Gravity Boom';
            app.GravityBoomPanel.FontSize = 16;
            app.GravityBoomPanel.Position = [447 423 592 174];

            % Create Switch
            app.Switch = uiswitch(app.GravityBoomPanel, 'toggle');
            app.Switch.ValueChangedFcn = createCallbackFcn(app, @SwitchValueChanged, true);
            app.Switch.Position = [31 61 20 45];

            % Create EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel
            app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel = uilabel(app.GravityBoomPanel);
            app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel.HorizontalAlignment = 'right';
            app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel.Visible = 'off';
            app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel.Position = [78 71 102 56];
            app.EndmasskgAssumesbrassdensity85gccforaerodynamicsEditFieldLabel.Text = {'End mass (kg):'; '(Assumes brass,'; 'density 8.5g/cc,'; 'for aerodynamics)'};

            % Create EndmasskgEditField
            app.EndmasskgEditField = uieditfield(app.GravityBoomPanel, 'numeric');
            app.EndmasskgEditField.Limits = [0 Inf];
            app.EndmasskgEditField.ValueChangedFcn = createCallbackFcn(app, @EndmasskgEditFieldValueChanged, true);
            app.EndmasskgEditField.Visible = 'off';
            app.EndmasskgEditField.Position = [197 105 46 22];

            % Create BoomlengthcmEditFieldLabel
            app.BoomlengthcmEditFieldLabel = uilabel(app.GravityBoomPanel);
            app.BoomlengthcmEditFieldLabel.HorizontalAlignment = 'right';
            app.BoomlengthcmEditFieldLabel.Visible = 'off';
            app.BoomlengthcmEditFieldLabel.Position = [72 35 110 22];
            app.BoomlengthcmEditFieldLabel.Text = 'Boom length (cm):';

            % Create BoomlengthcmEditField
            app.BoomlengthcmEditField = uieditfield(app.GravityBoomPanel, 'numeric');
            app.BoomlengthcmEditField.Limits = [0 Inf];
            app.BoomlengthcmEditField.ValueChangedFcn = createCallbackFcn(app, @BoomlengthcmEditFieldValueChanged, true);
            app.BoomlengthcmEditField.Visible = 'off';
            app.BoomlengthcmEditField.Position = [199 35 46 22];
            app.BoomlengthcmEditField.Value = 40;

            % Create DeploymentlatitudedegEditFieldLabel
            app.DeploymentlatitudedegEditFieldLabel = uilabel(app.GravityBoomPanel);
            app.DeploymentlatitudedegEditFieldLabel.HorizontalAlignment = 'right';
            app.DeploymentlatitudedegEditFieldLabel.Visible = 'off';
            app.DeploymentlatitudedegEditFieldLabel.Position = [279 50 146 22];
            app.DeploymentlatitudedegEditFieldLabel.Text = 'Deployment latitude (deg):';

            % Create DeploymentlatitudedegEditField
            app.DeploymentlatitudedegEditField = uieditfield(app.GravityBoomPanel, 'numeric');
            app.DeploymentlatitudedegEditField.Limits = [-90 90];
            app.DeploymentlatitudedegEditField.ValueChangedFcn = createCallbackFcn(app, @DeploymentlatitudedegEditFieldValueChanged, true);
            app.DeploymentlatitudedegEditField.Visible = 'off';
            app.DeploymentlatitudedegEditField.Position = [443 50 45 22];

            % Create BoomdeploymenttriggersLabel
            app.BoomdeploymenttriggersLabel = uilabel(app.GravityBoomPanel);
            app.BoomdeploymenttriggersLabel.Visible = 'off';
            app.BoomdeploymenttriggersLabel.Position = [313 115 158 22];
            app.BoomdeploymenttriggersLabel.Text = 'Boom deployment trigger(s):';

            % Create LatitudeCheckBox
            app.LatitudeCheckBox = uicheckbox(app.GravityBoomPanel);
            app.LatitudeCheckBox.ValueChangedFcn = createCallbackFcn(app, @LatitudeCheckBoxValueChanged, true);
            app.LatitudeCheckBox.Visible = 'off';
            app.LatitudeCheckBox.Text = 'Latitude';
            app.LatitudeCheckBox.Position = [279 84 66 22];
            app.LatitudeCheckBox.Value = true;

            % Create AttitudedeterminationCheckBox
            app.AttitudedeterminationCheckBox = uicheckbox(app.GravityBoomPanel);
            app.AttitudedeterminationCheckBox.ValueChangedFcn = createCallbackFcn(app, @AttitudedeterminationCheckBoxValueChanged, true);
            app.AttitudedeterminationCheckBox.Visible = 'off';
            app.AttitudedeterminationCheckBox.Text = 'Attitude determination';
            app.AttitudedeterminationCheckBox.Position = [353 84 141 22];

            % Create OrientationSwitchLabel
            app.OrientationSwitchLabel = uilabel(app.GravityBoomPanel);
            app.OrientationSwitchLabel.HorizontalAlignment = 'center';
            app.OrientationSwitchLabel.Visible = 'off';
            app.OrientationSwitchLabel.Position = [518 14 65 22];
            app.OrientationSwitchLabel.Text = 'Orientation';

            % Create OrientationSwitch
            app.OrientationSwitch = uiswitch(app.GravityBoomPanel, 'toggle');
            app.OrientationSwitch.Items = {'Nadir', 'Zenith'};
            app.OrientationSwitch.ValueChangedFcn = createCallbackFcn(app, @OrientationSwitchValueChanged, true);
            app.OrientationSwitch.Visible = 'off';
            app.OrientationSwitch.Position = [540 72 20 45];
            app.OrientationSwitch.Value = 'Zenith';

            % Create ADtriggerdurationminEditFieldLabel
            app.ADtriggerdurationminEditFieldLabel = uilabel(app.GravityBoomPanel);
            app.ADtriggerdurationminEditFieldLabel.HorizontalAlignment = 'right';
            app.ADtriggerdurationminEditFieldLabel.Visible = 'off';
            app.ADtriggerdurationminEditFieldLabel.Position = [285 14 140 22];
            app.ADtriggerdurationminEditFieldLabel.Text = 'AD trigger duration (min):';

            % Create ADtriggerdurationminEditField
            app.ADtriggerdurationminEditField = uieditfield(app.GravityBoomPanel, 'numeric');
            app.ADtriggerdurationminEditField.Limits = [0 Inf];
            app.ADtriggerdurationminEditField.ValueChangedFcn = createCallbackFcn(app, @ADtriggerdurationminEditFieldValueChanged, true);
            app.ADtriggerdurationminEditField.Visible = 'off';
            app.ADtriggerdurationminEditField.Position = [443 14 45 22];

            % Create ValidateButton
            app.ValidateButton = uibutton(app.CubeSatInputsTab, 'push');
            app.ValidateButton.ButtonPushedFcn = createCallbackFcn(app, @ValidateButtonPushed, true);
            app.ValidateButton.Position = [408 70 100 22];
            app.ValidateButton.Text = 'Validate';

            % Create ResetButton
            app.ResetButton = uibutton(app.CubeSatInputsTab, 'push');
            app.ResetButton.ButtonPushedFcn = createCallbackFcn(app, @ResetButtonPushed, true);
            app.ResetButton.Position = [556 70 100 22];
            app.ResetButton.Text = 'Reset';

            % Create CubeSatParametersLabel
            app.CubeSatParametersLabel = uilabel(app.CubeSatInputsTab);
            app.CubeSatParametersLabel.FontSize = 24;
            app.CubeSatParametersLabel.Position = [70 614 231 31];
            app.CubeSatParametersLabel.Text = 'CubeSat Parameters';

            % Create ActiveMagneticComponentsPanel
            app.ActiveMagneticComponentsPanel = uipanel(app.CubeSatInputsTab);
            app.ActiveMagneticComponentsPanel.Title = 'Active Magnetic Components';
            app.ActiveMagneticComponentsPanel.FontSize = 16;
            app.ActiveMagneticComponentsPanel.Position = [447 123 397 254];

            % Create Switch_2
            app.Switch_2 = uiswitch(app.ActiveMagneticComponentsPanel, 'slider');
            app.Switch_2.ValueChangedFcn = createCallbackFcn(app, @Switch_2ValueChanged, true);
            app.Switch_2.Position = [107 194 45 20];

            % Create TorqueroddipoleATM2EditFieldLabel
            app.TorqueroddipoleATM2EditFieldLabel = uilabel(app.ActiveMagneticComponentsPanel);
            app.TorqueroddipoleATM2EditFieldLabel.HorizontalAlignment = 'right';
            app.TorqueroddipoleATM2EditFieldLabel.Visible = 'off';
            app.TorqueroddipoleATM2EditFieldLabel.Position = [164 153 150 22];
            app.TorqueroddipoleATM2EditFieldLabel.Text = 'Torque rod dipole (ATM^2):';

            % Create TorqueroddipoleATM2EditField
            app.TorqueroddipoleATM2EditField = uieditfield(app.ActiveMagneticComponentsPanel, 'numeric');
            app.TorqueroddipoleATM2EditField.Limits = [0 Inf];
            app.TorqueroddipoleATM2EditField.ValueChangedFcn = createCallbackFcn(app, @TorqueroddipoleATM2EditFieldValueChanged, true);
            app.TorqueroddipoleATM2EditField.Visible = 'off';
            app.TorqueroddipoleATM2EditField.Position = [329 153 45 22];

            % Create TriggerlatitudedegEditFieldLabel
            app.TriggerlatitudedegEditFieldLabel = uilabel(app.ActiveMagneticComponentsPanel);
            app.TriggerlatitudedegEditFieldLabel.HorizontalAlignment = 'right';
            app.TriggerlatitudedegEditFieldLabel.Visible = 'off';
            app.TriggerlatitudedegEditFieldLabel.Position = [183 91 125 22];
            app.TriggerlatitudedegEditFieldLabel.Text = 'Trigger latitude (deg):';

            % Create TriggerlatitudedegEditField
            app.TriggerlatitudedegEditField = uieditfield(app.ActiveMagneticComponentsPanel, 'numeric');
            app.TriggerlatitudedegEditField.Limits = [-90 90];
            app.TriggerlatitudedegEditField.ValueChangedFcn = createCallbackFcn(app, @TriggerlatitudedegEditFieldValueChanged, true);
            app.TriggerlatitudedegEditField.Visible = 'off';
            app.TriggerlatitudedegEditField.Position = [323 91 46 22];

            % Create TorquerodaxisDropDownLabel
            app.TorquerodaxisDropDownLabel = uilabel(app.ActiveMagneticComponentsPanel);
            app.TorquerodaxisDropDownLabel.HorizontalAlignment = 'right';
            app.TorquerodaxisDropDownLabel.Visible = 'off';
            app.TorquerodaxisDropDownLabel.Position = [10 153 91 22];
            app.TorquerodaxisDropDownLabel.Text = 'Torque rod axis:';

            % Create TorquerodaxisDropDown
            app.TorquerodaxisDropDown = uidropdown(app.ActiveMagneticComponentsPanel);
            app.TorquerodaxisDropDown.Items = {'X', 'Y', 'Z'};
            app.TorquerodaxisDropDown.ValueChangedFcn = createCallbackFcn(app, @TorquerodaxisDropDownValueChanged, true);
            app.TorquerodaxisDropDown.Visible = 'off';
            app.TorquerodaxisDropDown.Position = [109 153 43 22];
            app.TorquerodaxisDropDown.Value = 'Z';

            % Create TorquerodtriggerSwitch
            app.TorquerodtriggerSwitch = uiswitch(app.ActiveMagneticComponentsPanel, 'toggle');
            app.TorquerodtriggerSwitch.Items = {'Triggered on (after detumble)', 'Initially on'};
            app.TorquerodtriggerSwitch.ValueChangedFcn = createCallbackFcn(app, @TorquerodtriggerSwitchValueChanged, true);
            app.TorquerodtriggerSwitch.Visible = 'off';
            app.TorquerodtriggerSwitch.Position = [100 68 20 45];
            app.TorquerodtriggerSwitch.Value = 'Initially on';

            % Create SimulationInputsTab
            app.SimulationInputsTab = uitab(app.TabGroup);
            app.SimulationInputsTab.Title = 'Simulation Inputs';

            % Create SimulationParametersLabel
            app.SimulationParametersLabel = uilabel(app.SimulationInputsTab);
            app.SimulationParametersLabel.FontSize = 24;
            app.SimulationParametersLabel.Position = [70 614 250 31];
            app.SimulationParametersLabel.Text = 'Simulation Parameters';

            % Create OrbitInformationPanel
            app.OrbitInformationPanel = uipanel(app.SimulationInputsTab);
            app.OrbitInformationPanel.Title = 'Orbit Information';
            app.OrbitInformationPanel.FontSize = 16;
            app.OrbitInformationPanel.Position = [22 289 481 268];

            % Create GridLayout
            app.GridLayout = uigridlayout(app.OrbitInformationPanel);
            app.GridLayout.ColumnWidth = {'fit', 32, 'fit', 'fit', 'fit'};
            app.GridLayout.RowHeight = {'fit', 'fit', 22, 22, 22, '1x'};

            % Create OrbitLabel
            app.OrbitLabel = uilabel(app.GridLayout);
            app.OrbitLabel.HorizontalAlignment = 'right';
            app.OrbitLabel.Layout.Row = 1;
            app.OrbitLabel.Layout.Column = 2;
            app.OrbitLabel.Text = 'Orbit:';

            % Create OrbitDropDown
            app.OrbitDropDown = uidropdown(app.GridLayout);
            app.OrbitDropDown.Items = {'Sun-Synch Polar (500 km)', 'ISS', 'Equatorial', 'Custom'};
            app.OrbitDropDown.ValueChangedFcn = createCallbackFcn(app, @OrbitDropDownValueChanged, true);
            app.OrbitDropDown.Layout.Row = 1;
            app.OrbitDropDown.Layout.Column = [3 4];
            app.OrbitDropDown.Value = 'Custom';

            % Create SemimajorAxiskmEditFieldLabel
            app.SemimajorAxiskmEditFieldLabel = uilabel(app.GridLayout);
            app.SemimajorAxiskmEditFieldLabel.HorizontalAlignment = 'right';
            app.SemimajorAxiskmEditFieldLabel.Layout.Row = 3;
            app.SemimajorAxiskmEditFieldLabel.Layout.Column = [1 2];
            app.SemimajorAxiskmEditFieldLabel.Text = 'Semimajor Axis (km):';

            % Create SemimajorAxiskmEditField
            app.SemimajorAxiskmEditField = uieditfield(app.GridLayout, 'numeric');
            app.SemimajorAxiskmEditField.Limits = [0 Inf];
            app.SemimajorAxiskmEditField.ValueChangedFcn = createCallbackFcn(app, @SemimajorAxiskmEditFieldValueChanged, true);
            app.SemimajorAxiskmEditField.Layout.Row = 3;
            app.SemimajorAxiskmEditField.Layout.Column = 3;

            % Create InclinationdegEditFieldLabel
            app.InclinationdegEditFieldLabel = uilabel(app.GridLayout);
            app.InclinationdegEditFieldLabel.HorizontalAlignment = 'right';
            app.InclinationdegEditFieldLabel.Layout.Row = 4;
            app.InclinationdegEditFieldLabel.Layout.Column = [1 2];
            app.InclinationdegEditFieldLabel.Text = 'Inclination (deg):';

            % Create InclinationdegEditField
            app.InclinationdegEditField = uieditfield(app.GridLayout, 'numeric');
            app.InclinationdegEditField.ValueChangedFcn = createCallbackFcn(app, @InclinationdegEditFieldValueChanged, true);
            app.InclinationdegEditField.Layout.Row = 4;
            app.InclinationdegEditField.Layout.Column = 3;

            % Create LongofAscNodedegEditFieldLabel
            app.LongofAscNodedegEditFieldLabel = uilabel(app.GridLayout);
            app.LongofAscNodedegEditFieldLabel.HorizontalAlignment = 'right';
            app.LongofAscNodedegEditFieldLabel.Layout.Row = 5;
            app.LongofAscNodedegEditFieldLabel.Layout.Column = [1 2];
            app.LongofAscNodedegEditFieldLabel.Text = 'Long. of Asc. Node (deg):';

            % Create LongofAscNodedegEditField
            app.LongofAscNodedegEditField = uieditfield(app.GridLayout, 'numeric');
            app.LongofAscNodedegEditField.ValueChangedFcn = createCallbackFcn(app, @LongofAscNodedegEditFieldValueChanged, true);
            app.LongofAscNodedegEditField.Layout.Row = 5;
            app.LongofAscNodedegEditField.Layout.Column = 3;

            % Create ArgofPeriapsedegLabel
            app.ArgofPeriapsedegLabel = uilabel(app.GridLayout);
            app.ArgofPeriapsedegLabel.HorizontalAlignment = 'right';
            app.ArgofPeriapsedegLabel.Layout.Row = 3;
            app.ArgofPeriapsedegLabel.Layout.Column = 4;
            app.ArgofPeriapsedegLabel.Text = 'Arg. of Periapse (deg):';

            % Create ArgofPeriapsedegEditField
            app.ArgofPeriapsedegEditField = uieditfield(app.GridLayout, 'numeric');
            app.ArgofPeriapsedegEditField.ValueChangedFcn = createCallbackFcn(app, @ArgofPeriapsedegEditFieldValueChanged, true);
            app.ArgofPeriapsedegEditField.Layout.Row = 3;
            app.ArgofPeriapsedegEditField.Layout.Column = 5;

            % Create EccentricityLabel
            app.EccentricityLabel = uilabel(app.GridLayout);
            app.EccentricityLabel.HorizontalAlignment = 'right';
            app.EccentricityLabel.Layout.Row = 4;
            app.EccentricityLabel.Layout.Column = 4;
            app.EccentricityLabel.Text = 'Eccentricity:';

            % Create EccentricityEditField
            app.EccentricityEditField = uieditfield(app.GridLayout, 'numeric');
            app.EccentricityEditField.Limits = [0 1];
            app.EccentricityEditField.ValueChangedFcn = createCallbackFcn(app, @EccentricityEditFieldValueChanged, true);
            app.EccentricityEditField.Layout.Row = 4;
            app.EccentricityEditField.Layout.Column = 5;

            % Create MeanAnomalydegLabel
            app.MeanAnomalydegLabel = uilabel(app.GridLayout);
            app.MeanAnomalydegLabel.HorizontalAlignment = 'right';
            app.MeanAnomalydegLabel.Layout.Row = 5;
            app.MeanAnomalydegLabel.Layout.Column = 4;
            app.MeanAnomalydegLabel.Text = 'Mean Anomaly (deg):';

            % Create MeanAnomalydegEditField
            app.MeanAnomalydegEditField = uieditfield(app.GridLayout, 'numeric');
            app.MeanAnomalydegEditField.ValueChangedFcn = createCallbackFcn(app, @MeanAnomalydegEditFieldValueChanged, true);
            app.MeanAnomalydegEditField.Layout.Row = 5;
            app.MeanAnomalydegEditField.Layout.Column = 5;

            % Create AltitudekmEditFieldLabel
            app.AltitudekmEditFieldLabel = uilabel(app.GridLayout);
            app.AltitudekmEditFieldLabel.HorizontalAlignment = 'right';
            app.AltitudekmEditFieldLabel.Layout.Row = 2;
            app.AltitudekmEditFieldLabel.Layout.Column = 3;
            app.AltitudekmEditFieldLabel.Text = 'Altitude (km):';

            % Create AltitudekmEditField
            app.AltitudekmEditField = uieditfield(app.GridLayout, 'numeric');
            app.AltitudekmEditField.ValueChangedFcn = createCallbackFcn(app, @AltitudekmEditFieldValueChanged, true);
            app.AltitudekmEditField.Layout.Row = 2;
            app.AltitudekmEditField.Layout.Column = 4;

            % Create InitialtipoffratesPanel
            app.InitialtipoffratesPanel = uipanel(app.GridLayout);
            app.InitialtipoffratesPanel.Title = 'Initial tipoff rates:';
            app.InitialtipoffratesPanel.Layout.Row = 6;
            app.InitialtipoffratesPanel.Layout.Column = [1 5];

            % Create GridLayout3
            app.GridLayout3 = uigridlayout(app.InitialtipoffratesPanel);
            app.GridLayout3.ColumnWidth = {56, 40, 57, 40, 56, 40};
            app.GridLayout3.RowHeight = {22};

            % Create XdegsEditFieldLabel
            app.XdegsEditFieldLabel = uilabel(app.GridLayout3);
            app.XdegsEditFieldLabel.HorizontalAlignment = 'right';
            app.XdegsEditFieldLabel.Layout.Row = 1;
            app.XdegsEditFieldLabel.Layout.Column = 1;
            app.XdegsEditFieldLabel.Text = 'X (deg/s):';

            % Create XdegsEditField
            app.XdegsEditField = uieditfield(app.GridLayout3, 'numeric');
            app.XdegsEditField.ValueChangedFcn = createCallbackFcn(app, @XdegsEditFieldValueChanged, true);
            app.XdegsEditField.Layout.Row = 1;
            app.XdegsEditField.Layout.Column = 2;

            % Create YdegsEditFieldLabel
            app.YdegsEditFieldLabel = uilabel(app.GridLayout3);
            app.YdegsEditFieldLabel.HorizontalAlignment = 'right';
            app.YdegsEditFieldLabel.Layout.Row = 1;
            app.YdegsEditFieldLabel.Layout.Column = 3;
            app.YdegsEditFieldLabel.Text = 'Y (deg/s):';

            % Create YdegsEditField
            app.YdegsEditField = uieditfield(app.GridLayout3, 'numeric');
            app.YdegsEditField.ValueChangedFcn = createCallbackFcn(app, @YdegsEditFieldValueChanged, true);
            app.YdegsEditField.Layout.Row = 1;
            app.YdegsEditField.Layout.Column = 4;

            % Create ZdegsEditFieldLabel
            app.ZdegsEditFieldLabel = uilabel(app.GridLayout3);
            app.ZdegsEditFieldLabel.HorizontalAlignment = 'right';
            app.ZdegsEditFieldLabel.Layout.Row = 1;
            app.ZdegsEditFieldLabel.Layout.Column = 5;
            app.ZdegsEditFieldLabel.Text = 'Z (deg/s):';

            % Create ZdegsEditField
            app.ZdegsEditField = uieditfield(app.GridLayout3, 'numeric');
            app.ZdegsEditField.ValueChangedFcn = createCallbackFcn(app, @ZdegsEditFieldValueChanged, true);
            app.ZdegsEditField.Layout.Row = 1;
            app.ZdegsEditField.Layout.Column = 6;

            % Create SimulationPanel
            app.SimulationPanel = uipanel(app.SimulationInputsTab);
            app.SimulationPanel.Title = 'Simulation';
            app.SimulationPanel.FontSize = 16;
            app.SimulationPanel.Position = [514 301 267 256];

            % Create GridLayout2
            app.GridLayout2 = uigridlayout(app.SimulationPanel);
            app.GridLayout2.ColumnWidth = {32, 36, 85, '1x'};
            app.GridLayout2.RowHeight = {22, 22, '1x', 22, 22, 22, '1x'};

            % Create StartDateLabel
            app.StartDateLabel = uilabel(app.GridLayout2);
            app.StartDateLabel.HorizontalAlignment = 'right';
            app.StartDateLabel.Layout.Row = 1;
            app.StartDateLabel.Layout.Column = [1 2];
            app.StartDateLabel.Text = 'Start Date:';

            % Create StartDateDatePicker
            app.StartDateDatePicker = uidatepicker(app.GridLayout2);
            app.StartDateDatePicker.ValueChangedFcn = createCallbackFcn(app, @StartDateDatePickerValueChanged, true);
            app.StartDateDatePicker.Layout.Row = 1;
            app.StartDateDatePicker.Layout.Column = [3 4];

            % Create SimulationdurationorbitsEditFieldLabel
            app.SimulationdurationorbitsEditFieldLabel = uilabel(app.GridLayout2);
            app.SimulationdurationorbitsEditFieldLabel.HorizontalAlignment = 'right';
            app.SimulationdurationorbitsEditFieldLabel.Layout.Row = 2;
            app.SimulationdurationorbitsEditFieldLabel.Layout.Column = [1 3];
            app.SimulationdurationorbitsEditFieldLabel.Text = 'Simulation duration (orbits):';

            % Create SimulationdurationorbitsEditField
            app.SimulationdurationorbitsEditField = uieditfield(app.GridLayout2, 'numeric');
            app.SimulationdurationorbitsEditField.Limits = [0 Inf];
            app.SimulationdurationorbitsEditField.ValueChangedFcn = createCallbackFcn(app, @SimulationdurationorbitsEditFieldValueChanged, true);
            app.SimulationdurationorbitsEditField.Layout.Row = 2;
            app.SimulationdurationorbitsEditField.Layout.Column = 4;
            app.SimulationdurationorbitsEditField.Value = 50;

            % Create NadirpointingreqdegEditFieldLabel
            app.NadirpointingreqdegEditFieldLabel = uilabel(app.GridLayout2);
            app.NadirpointingreqdegEditFieldLabel.HorizontalAlignment = 'right';
            app.NadirpointingreqdegEditFieldLabel.Layout.Row = 4;
            app.NadirpointingreqdegEditFieldLabel.Layout.Column = [1 3];
            app.NadirpointingreqdegEditFieldLabel.Text = 'Nadir pointing req (+/- deg):';

            % Create NadirpointingreqdegEditField
            app.NadirpointingreqdegEditField = uieditfield(app.GridLayout2, 'numeric');
            app.NadirpointingreqdegEditField.Limits = [0 Inf];
            app.NadirpointingreqdegEditField.ValueChangedFcn = createCallbackFcn(app, @NadirpointingreqdegEditFieldValueChanged, true);
            app.NadirpointingreqdegEditField.Layout.Row = 4;
            app.NadirpointingreqdegEditField.Layout.Column = 4;
            app.NadirpointingreqdegEditField.Value = 5;

            % Create DesiredofnadirpointingEditFieldLabel
            app.DesiredofnadirpointingEditFieldLabel = uilabel(app.GridLayout2);
            app.DesiredofnadirpointingEditFieldLabel.HorizontalAlignment = 'right';
            app.DesiredofnadirpointingEditFieldLabel.Layout.Row = 5;
            app.DesiredofnadirpointingEditFieldLabel.Layout.Column = [1 3];
            app.DesiredofnadirpointingEditFieldLabel.Text = 'Desired % of nadir pointing:';

            % Create DesiredofnadirpointingEditField
            app.DesiredofnadirpointingEditField = uieditfield(app.GridLayout2, 'numeric');
            app.DesiredofnadirpointingEditField.Limits = [0 100];
            app.DesiredofnadirpointingEditField.ValueChangedFcn = createCallbackFcn(app, @DesiredofnadirpointingEditFieldValueChanged, true);
            app.DesiredofnadirpointingEditField.Layout.Row = 5;
            app.DesiredofnadirpointingEditField.Layout.Column = 4;
            app.DesiredofnadirpointingEditField.Value = 100;

            % Create NorthpointingreqdegEditFieldLabel
            app.NorthpointingreqdegEditFieldLabel = uilabel(app.GridLayout2);
            app.NorthpointingreqdegEditFieldLabel.HorizontalAlignment = 'right';
            app.NorthpointingreqdegEditFieldLabel.Layout.Row = 6;
            app.NorthpointingreqdegEditFieldLabel.Layout.Column = [1 3];
            app.NorthpointingreqdegEditFieldLabel.Text = 'North pointing req (+/- deg):';

            % Create NorthpointingreqdegEditField
            app.NorthpointingreqdegEditField = uieditfield(app.GridLayout2, 'numeric');
            app.NorthpointingreqdegEditField.Limits = [0 Inf];
            app.NorthpointingreqdegEditField.ValueChangedFcn = createCallbackFcn(app, @NorthpointingreqdegEditFieldValueChanged, true);
            app.NorthpointingreqdegEditField.Layout.Row = 6;
            app.NorthpointingreqdegEditField.Layout.Column = 4;
            app.NorthpointingreqdegEditField.Value = 5;

            % Create DesiredofnorthpointingEditFieldLabel
            app.DesiredofnorthpointingEditFieldLabel = uilabel(app.GridLayout2);
            app.DesiredofnorthpointingEditFieldLabel.HorizontalAlignment = 'right';
            app.DesiredofnorthpointingEditFieldLabel.Layout.Row = 7;
            app.DesiredofnorthpointingEditFieldLabel.Layout.Column = [1 3];
            app.DesiredofnorthpointingEditFieldLabel.Text = 'Desired % of north pointing:';

            % Create DesiredofnorthpointingEditField
            app.DesiredofnorthpointingEditField = uieditfield(app.GridLayout2, 'numeric');
            app.DesiredofnorthpointingEditField.Limits = [0 100];
            app.DesiredofnorthpointingEditField.ValueChangedFcn = createCallbackFcn(app, @DesiredofnorthpointingEditFieldValueChanged, true);
            app.DesiredofnorthpointingEditField.Layout.Row = 7;
            app.DesiredofnorthpointingEditField.Layout.Column = 4;
            app.DesiredofnorthpointingEditField.Value = 100;

            % Create TimestepsEditFieldLabel
            app.TimestepsEditFieldLabel = uilabel(app.GridLayout2);
            app.TimestepsEditFieldLabel.HorizontalAlignment = 'right';
            app.TimestepsEditFieldLabel.Layout.Row = 3;
            app.TimestepsEditFieldLabel.Layout.Column = [1 3];
            app.TimestepsEditFieldLabel.Text = 'Time step (s):';

            % Create TimestepsEditField
            app.TimestepsEditField = uieditfield(app.GridLayout2, 'numeric');
            app.TimestepsEditField.Limits = [0 Inf];
            app.TimestepsEditField.ValueChangedFcn = createCallbackFcn(app, @TimestepsEditFieldValueChanged, true);
            app.TimestepsEditField.Layout.Row = 3;
            app.TimestepsEditField.Layout.Column = 4;
            app.TimestepsEditField.Value = 2.5;

            % Create RunSimulationButton
            app.RunSimulationButton = uibutton(app.SimulationInputsTab, 'push');
            app.RunSimulationButton.ButtonPushedFcn = createCallbackFcn(app, @RunSimulationButtonPushed, true);
            app.RunSimulationButton.BackgroundColor = [1 0 0];
            app.RunSimulationButton.FontSize = 20;
            app.RunSimulationButton.FontWeight = 'bold';
            app.RunSimulationButton.Position = [626 202 217 82];
            app.RunSimulationButton.Text = 'Run Simulation';

            % Create DetumbleSuccessCriteriaPanel
            app.DetumbleSuccessCriteriaPanel = uipanel(app.SimulationInputsTab);
            app.DetumbleSuccessCriteriaPanel.Title = 'Detumble Success Criteria';
            app.DetumbleSuccessCriteriaPanel.FontSize = 16;
            app.DetumbleSuccessCriteriaPanel.Position = [23 163 493 111];

            % Create RadiodetumblethresholdrpmEditFieldLabel
            app.RadiodetumblethresholdrpmEditFieldLabel = uilabel(app.DetumbleSuccessCriteriaPanel);
            app.RadiodetumblethresholdrpmEditFieldLabel.HorizontalAlignment = 'right';
            app.RadiodetumblethresholdrpmEditFieldLabel.Position = [9 49 178 22];
            app.RadiodetumblethresholdrpmEditFieldLabel.Text = 'Radio detumble threshold (rpm):';

            % Create RadiodetumblethresholdrpmEditField
            app.RadiodetumblethresholdrpmEditField = uieditfield(app.DetumbleSuccessCriteriaPanel, 'numeric');
            app.RadiodetumblethresholdrpmEditField.Limits = [0 Inf];
            app.RadiodetumblethresholdrpmEditField.ValueChangedFcn = createCallbackFcn(app, @RadiodetumblethresholdrpmEditFieldValueChanged, true);
            app.RadiodetumblethresholdrpmEditField.Position = [193 49 36 22];
            app.RadiodetumblethresholdrpmEditField.Value = 3;

            % Create AttitudedetumblethresholddegsEditFieldLabel
            app.AttitudedetumblethresholddegsEditFieldLabel = uilabel(app.DetumbleSuccessCriteriaPanel);
            app.AttitudedetumblethresholddegsEditFieldLabel.HorizontalAlignment = 'right';
            app.AttitudedetumblethresholddegsEditFieldLabel.Position = [240 49 199 22];
            app.AttitudedetumblethresholddegsEditFieldLabel.Text = 'Attitude detumble threshold (deg/s):';

            % Create AttitudedetumblethresholddegsEditField
            app.AttitudedetumblethresholddegsEditField = uieditfield(app.DetumbleSuccessCriteriaPanel, 'numeric');
            app.AttitudedetumblethresholddegsEditField.Limits = [0 Inf];
            app.AttitudedetumblethresholddegsEditField.ValueChangedFcn = createCallbackFcn(app, @AttitudedetumblethresholddegsEditFieldValueChanged, true);
            app.AttitudedetumblethresholddegsEditField.Position = [444 49 36 22];
            app.AttitudedetumblethresholddegsEditField.Value = 0.1;

            % Create AttitudedetumbledurationminEditFieldLabel
            app.AttitudedetumbledurationminEditFieldLabel = uilabel(app.DetumbleSuccessCriteriaPanel);
            app.AttitudedetumbledurationminEditFieldLabel.HorizontalAlignment = 'right';
            app.AttitudedetumbledurationminEditFieldLabel.Position = [258 18 181 22];
            app.AttitudedetumbledurationminEditFieldLabel.Text = 'Attitude detumble duration (min):';

            % Create AttitudedetumbledurationminEditField
            app.AttitudedetumbledurationminEditField = uieditfield(app.DetumbleSuccessCriteriaPanel, 'numeric');
            app.AttitudedetumbledurationminEditField.Limits = [0 Inf];
            app.AttitudedetumbledurationminEditField.ValueChangedFcn = createCallbackFcn(app, @AttitudedetumbledurationminEditFieldValueChanged, true);
            app.AttitudedetumbledurationminEditField.Position = [444 18 36 22];

            % Create AttitudeDeterminationPanel
            app.AttitudeDeterminationPanel = uipanel(app.SimulationInputsTab);
            app.AttitudeDeterminationPanel.Title = 'Attitude Determination';
            app.AttitudeDeterminationPanel.FontSize = 16;
            app.AttitudeDeterminationPanel.Position = [795 415 264 142];

            % Create GridLayout14
            app.GridLayout14 = uigridlayout(app.AttitudeDeterminationPanel);
            app.GridLayout14.ColumnWidth = {177, '1x'};
            app.GridLayout14.RowHeight = {21, 21, 22};
            app.GridLayout14.ColumnSpacing = 9;
            app.GridLayout14.RowSpacing = 13.25;
            app.GridLayout14.Padding = [9 13.25 9 13.25];

            % Create IMUsampleperiodsecEditFieldLabel
            app.IMUsampleperiodsecEditFieldLabel = uilabel(app.GridLayout14);
            app.IMUsampleperiodsecEditFieldLabel.HorizontalAlignment = 'right';
            app.IMUsampleperiodsecEditFieldLabel.Layout.Row = 1;
            app.IMUsampleperiodsecEditFieldLabel.Layout.Column = 1;
            app.IMUsampleperiodsecEditFieldLabel.Text = 'IMU sample period (sec):';

            % Create IMUsampleperiodsecEditField
            app.IMUsampleperiodsecEditField = uieditfield(app.GridLayout14, 'numeric');
            app.IMUsampleperiodsecEditField.Limits = [0 Inf];
            app.IMUsampleperiodsecEditField.ValueChangedFcn = createCallbackFcn(app, @IMUsampleperiodsecEditFieldValueChanged, true);
            app.IMUsampleperiodsecEditField.Layout.Row = 1;
            app.IMUsampleperiodsecEditField.Layout.Column = 2;
            app.IMUsampleperiodsecEditField.Value = 60;

            % Create IRsensorFOVhalfangledegEditFieldLabel
            app.IRsensorFOVhalfangledegEditFieldLabel = uilabel(app.GridLayout14);
            app.IRsensorFOVhalfangledegEditFieldLabel.HorizontalAlignment = 'right';
            app.IRsensorFOVhalfangledegEditFieldLabel.Layout.Row = 2;
            app.IRsensorFOVhalfangledegEditFieldLabel.Layout.Column = 1;
            app.IRsensorFOVhalfangledegEditFieldLabel.Text = 'IR sensor FOV half-angle (deg):';

            % Create IRsensorFOVhalfangledegEditField
            app.IRsensorFOVhalfangledegEditField = uieditfield(app.GridLayout14, 'numeric');
            app.IRsensorFOVhalfangledegEditField.Limits = [0 Inf];
            app.IRsensorFOVhalfangledegEditField.ValueChangedFcn = createCallbackFcn(app, @IRsensorFOVhalfangledegEditFieldValueChanged, true);
            app.IRsensorFOVhalfangledegEditField.Layout.Row = 2;
            app.IRsensorFOVhalfangledegEditField.Layout.Column = 2;
            app.IRsensorFOVhalfangledegEditField.Value = 0.5;

            % Create IRsensortriggerdeviationdegEditFieldLabel
            app.IRsensortriggerdeviationdegEditFieldLabel = uilabel(app.GridLayout14);
            app.IRsensortriggerdeviationdegEditFieldLabel.HorizontalAlignment = 'right';
            app.IRsensortriggerdeviationdegEditFieldLabel.Layout.Row = 3;
            app.IRsensortriggerdeviationdegEditFieldLabel.Layout.Column = 1;
            app.IRsensortriggerdeviationdegEditFieldLabel.Text = 'IR sensor trigger deviation (deg):';

            % Create IRsensortriggerdeviationdegEditField
            app.IRsensortriggerdeviationdegEditField = uieditfield(app.GridLayout14, 'numeric');
            app.IRsensortriggerdeviationdegEditField.Limits = [0 Inf];
            app.IRsensortriggerdeviationdegEditField.ValueChangedFcn = createCallbackFcn(app, @IRsensortriggerdeviationdegEditFieldValueChanged, true);
            app.IRsensortriggerdeviationdegEditField.Layout.Row = 3;
            app.IRsensortriggerdeviationdegEditField.Layout.Column = 2;
            app.IRsensortriggerdeviationdegEditField.Value = 10;

            % Create ComputeAerodynamicsKnobLabel
            app.ComputeAerodynamicsKnobLabel = uilabel(app.SimulationInputsTab);
            app.ComputeAerodynamicsKnobLabel.HorizontalAlignment = 'center';
            app.ComputeAerodynamicsKnobLabel.FontSize = 14;
            app.ComputeAerodynamicsKnobLabel.Position = [871 272 157 22];
            app.ComputeAerodynamicsKnobLabel.Text = 'Compute Aerodynamics';

            % Create ComputeAerodynamicsKnob
            app.ComputeAerodynamicsKnob = uiknob(app.SimulationInputsTab, 'discrete');
            app.ComputeAerodynamicsKnob.Items = {'Never', 'After Boom Deployment', 'Always'};
            app.ComputeAerodynamicsKnob.ValueChangedFcn = createCallbackFcn(app, @ComputeAerodynamicsKnobValueChanged, true);
            app.ComputeAerodynamicsKnob.FontSize = 14;
            app.ComputeAerodynamicsKnob.Position = [919 309 60 60];
            app.ComputeAerodynamicsKnob.Value = 'Never';

            % Create LoadfromFilePanel
            app.LoadfromFilePanel = uipanel(app.SimulationInputsTab);
            app.LoadfromFilePanel.Title = 'Load from File';
            app.LoadfromFilePanel.FontSize = 18;
            app.LoadfromFilePanel.Position = [842 21 303 161];

            % Create FileNameLabel
            app.FileNameLabel = uilabel(app.LoadfromFilePanel);
            app.FileNameLabel.HorizontalAlignment = 'right';
            app.FileNameLabel.Position = [13 105 63 22];
            app.FileNameLabel.Text = 'File Name:';

            % Create FileNameEditField
            app.FileNameEditField = uieditfield(app.LoadfromFilePanel, 'text');
            app.FileNameEditField.HorizontalAlignment = 'right';
            app.FileNameEditField.Position = [91 105 203 22];
            app.FileNameEditField.Value = 'filename.mat';

            % Create LoadButton
            app.LoadButton = uibutton(app.LoadfromFilePanel, 'push');
            app.LoadButton.ButtonPushedFcn = createCallbackFcn(app, @LoadButtonPushed, true);
            app.LoadButton.BackgroundColor = [0 0.4471 0.7412];
            app.LoadButton.FontSize = 20;
            app.LoadButton.FontWeight = 'bold';
            app.LoadButton.Position = [77 12 157 68];
            app.LoadButton.Text = 'Load';

            % Create SavetoFilePanel
            app.SavetoFilePanel = uipanel(app.SimulationInputsTab);
            app.SavetoFilePanel.Title = 'Save to File';
            app.SavetoFilePanel.FontSize = 18;
            app.SavetoFilePanel.Position = [535 21 294 161];

            % Create SaveButton
            app.SaveButton = uibutton(app.SavetoFilePanel, 'push');
            app.SaveButton.ButtonPushedFcn = createCallbackFcn(app, @SaveButtonPushed, true);
            app.SaveButton.BackgroundColor = [0.4667 0.6745 0.1882];
            app.SaveButton.FontSize = 20;
            app.SaveButton.FontWeight = 'bold';
            app.SaveButton.Visible = 'off';
            app.SaveButton.Position = [50 12 194 68];
            app.SaveButton.Text = 'Save';

            % Create FileNameEditField_2Label
            app.FileNameEditField_2Label = uilabel(app.SavetoFilePanel);
            app.FileNameEditField_2Label.HorizontalAlignment = 'right';
            app.FileNameEditField_2Label.Position = [11 105 63 22];
            app.FileNameEditField_2Label.Text = 'File Name:';

            % Create FileNameEditField_2
            app.FileNameEditField_2 = uieditfield(app.SavetoFilePanel, 'text');
            app.FileNameEditField_2.HorizontalAlignment = 'right';
            app.FileNameEditField_2.Position = [89 105 193 22];
            app.FileNameEditField_2.Value = 'filename.mat';

            % Create OrbitVisualizationTab
            app.OrbitVisualizationTab = uitab(app.TabGroup);
            app.OrbitVisualizationTab.Title = 'Orbit Visualization';

            % Create OrbitInformationLLACoordinatesPanel
            app.OrbitInformationLLACoordinatesPanel = uipanel(app.OrbitVisualizationTab);
            app.OrbitInformationLLACoordinatesPanel.Title = 'Orbit Information (LLA Coordinates)';
            app.OrbitInformationLLACoordinatesPanel.FontSize = 16;
            app.OrbitInformationLLACoordinatesPanel.Position = [96 109 471 508];

            % Create GridLayout5
            app.GridLayout5 = uigridlayout(app.OrbitInformationLLACoordinatesPanel);
            app.GridLayout5.ColumnWidth = {'1x'};
            app.GridLayout5.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout5.Padding = [20 10 20 10];

            % Create OrbitX
            app.OrbitX = uiaxes(app.GridLayout5);
            title(app.OrbitX, '')
            xlabel(app.OrbitX, '')
            ylabel(app.OrbitX, 'Latitude (\circ)')
            app.OrbitX.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.OrbitX.Layout.Row = 1;
            app.OrbitX.Layout.Column = 1;

            % Create OrbitY
            app.OrbitY = uiaxes(app.GridLayout5);
            title(app.OrbitY, '')
            xlabel(app.OrbitY, '')
            ylabel(app.OrbitY, 'Longitude (\circ)')
            app.OrbitY.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.OrbitY.Layout.Row = 2;
            app.OrbitY.Layout.Column = 1;

            % Create OrbitZ
            app.OrbitZ = uiaxes(app.GridLayout5);
            title(app.OrbitZ, '')
            xlabel(app.OrbitZ, 'Orbits')
            ylabel(app.OrbitZ, 'Altitude (km)')
            app.OrbitZ.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.OrbitZ.Layout.Row = 3;
            app.OrbitZ.Layout.Column = 1;

            % Create DisplayGroundTrackButton
            app.DisplayGroundTrackButton = uibutton(app.OrbitVisualizationTab, 'push');
            app.DisplayGroundTrackButton.ButtonPushedFcn = createCallbackFcn(app, @DisplayGroundTrackButtonPushed, true);
            app.DisplayGroundTrackButton.BackgroundColor = [1 1 1];
            app.DisplayGroundTrackButton.FontSize = 16;
            app.DisplayGroundTrackButton.FontWeight = 'bold';
            app.DisplayGroundTrackButton.Position = [668 391 219 49];
            app.DisplayGroundTrackButton.Text = 'Display Ground Track';

            % Create Display3DOrbitButton
            app.Display3DOrbitButton = uibutton(app.OrbitVisualizationTab, 'push');
            app.Display3DOrbitButton.ButtonPushedFcn = createCallbackFcn(app, @Display3DOrbitButtonPushed, true);
            app.Display3DOrbitButton.BackgroundColor = [1 1 1];
            app.Display3DOrbitButton.FontSize = 16;
            app.Display3DOrbitButton.FontWeight = 'bold';
            app.Display3DOrbitButton.Position = [668 304 219 49];
            app.Display3DOrbitButton.Text = 'Display 3D Orbit';

            % Create DisturbancesTab
            app.DisturbancesTab = uitab(app.TabGroup);
            app.DisturbancesTab.Title = 'Disturbances';

            % Create TabGroup3
            app.TabGroup3 = uitabgroup(app.DisturbancesTab);
            app.TabGroup3.Position = [0 1 1199 674];

            % Create Torques1Tab
            app.Torques1Tab = uitab(app.TabGroup3);
            app.Torques1Tab.Title = 'Torques (1)';

            % Create MagneticTorquesPanel
            app.MagneticTorquesPanel = uipanel(app.Torques1Tab);
            app.MagneticTorquesPanel.Title = 'Magnetic Torques';
            app.MagneticTorquesPanel.FontSize = 16;
            app.MagneticTorquesPanel.Position = [11 148 392 467];

            % Create GridLayout4_7
            app.GridLayout4_7 = uigridlayout(app.MagneticTorquesPanel);
            app.GridLayout4_7.ColumnWidth = {'1x'};
            app.GridLayout4_7.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_7.Padding = [20 10 20 10];

            % Create MagTorqueX
            app.MagTorqueX = uiaxes(app.GridLayout4_7);
            title(app.MagTorqueX, '')
            xlabel(app.MagTorqueX, '')
            ylabel(app.MagTorqueX, 'T_x (Nm)')
            app.MagTorqueX.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.MagTorqueX.Layout.Row = 1;
            app.MagTorqueX.Layout.Column = 1;

            % Create MagTorqueY
            app.MagTorqueY = uiaxes(app.GridLayout4_7);
            title(app.MagTorqueY, '')
            xlabel(app.MagTorqueY, '')
            ylabel(app.MagTorqueY, 'T_y (Nm)')
            app.MagTorqueY.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.MagTorqueY.Layout.Row = 2;
            app.MagTorqueY.Layout.Column = 1;

            % Create MagTorqueZ
            app.MagTorqueZ = uiaxes(app.GridLayout4_7);
            title(app.MagTorqueZ, '')
            xlabel(app.MagTorqueZ, 'Orbits')
            ylabel(app.MagTorqueZ, 'T_z (Nm)')
            app.MagTorqueZ.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.MagTorqueZ.Layout.Row = 3;
            app.MagTorqueZ.Layout.Column = 1;

            % Create HysteresisDampingTorquesPanel
            app.HysteresisDampingTorquesPanel = uipanel(app.Torques1Tab);
            app.HysteresisDampingTorquesPanel.Title = 'Hysteresis (Damping) Torques';
            app.HysteresisDampingTorquesPanel.FontSize = 16;
            app.HysteresisDampingTorquesPanel.Position = [401 148 392 467];

            % Create GridLayout4_9
            app.GridLayout4_9 = uigridlayout(app.HysteresisDampingTorquesPanel);
            app.GridLayout4_9.ColumnWidth = {'1x'};
            app.GridLayout4_9.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_9.Padding = [20 10 20 10];

            % Create HystTorqueX
            app.HystTorqueX = uiaxes(app.GridLayout4_9);
            title(app.HystTorqueX, '')
            xlabel(app.HystTorqueX, '')
            ylabel(app.HystTorqueX, 'T_x (Nm)')
            app.HystTorqueX.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.HystTorqueX.Layout.Row = 1;
            app.HystTorqueX.Layout.Column = 1;

            % Create HystTorqueY
            app.HystTorqueY = uiaxes(app.GridLayout4_9);
            title(app.HystTorqueY, '')
            xlabel(app.HystTorqueY, '')
            ylabel(app.HystTorqueY, 'T_y (Nm)')
            app.HystTorqueY.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.HystTorqueY.Layout.Row = 2;
            app.HystTorqueY.Layout.Column = 1;

            % Create HystTorqueZ
            app.HystTorqueZ = uiaxes(app.GridLayout4_9);
            title(app.HystTorqueZ, '')
            xlabel(app.HystTorqueZ, 'Orbits')
            ylabel(app.HystTorqueZ, 'T_z (Nm)')
            app.HystTorqueZ.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.HystTorqueZ.Layout.Row = 3;
            app.HystTorqueZ.Layout.Column = 1;

            % Create GravityGradientTorquesPanel
            app.GravityGradientTorquesPanel = uipanel(app.Torques1Tab);
            app.GravityGradientTorquesPanel.Title = 'Gravity Gradient Torques';
            app.GravityGradientTorquesPanel.FontSize = 16;
            app.GravityGradientTorquesPanel.Position = [791 148 392 467];

            % Create GridLayout4_8
            app.GridLayout4_8 = uigridlayout(app.GravityGradientTorquesPanel);
            app.GridLayout4_8.ColumnWidth = {'1x'};
            app.GridLayout4_8.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_8.Padding = [20 10 20 10];

            % Create GGTorqueX
            app.GGTorqueX = uiaxes(app.GridLayout4_8);
            title(app.GGTorqueX, '')
            xlabel(app.GGTorqueX, '')
            ylabel(app.GGTorqueX, 'T_x (Nm)')
            app.GGTorqueX.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.GGTorqueX.Layout.Row = 1;
            app.GGTorqueX.Layout.Column = 1;

            % Create GGTorqueY
            app.GGTorqueY = uiaxes(app.GridLayout4_8);
            title(app.GGTorqueY, '')
            xlabel(app.GGTorqueY, '')
            ylabel(app.GGTorqueY, 'T_y (Nm)')
            app.GGTorqueY.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.GGTorqueY.Layout.Row = 2;
            app.GGTorqueY.Layout.Column = 1;

            % Create GGTorqueZ
            app.GGTorqueZ = uiaxes(app.GridLayout4_8);
            title(app.GGTorqueZ, '')
            xlabel(app.GGTorqueZ, 'Orbits')
            ylabel(app.GGTorqueZ, 'T_z (Nm)')
            app.GGTorqueZ.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.GGTorqueZ.Layout.Row = 3;
            app.GGTorqueZ.Layout.Column = 1;

            % Create Torques2Tab
            app.Torques2Tab = uitab(app.TabGroup3);
            app.Torques2Tab.Title = 'Torques (2)';

            % Create AerodynamicTorquesPanel
            app.AerodynamicTorquesPanel = uipanel(app.Torques2Tab);
            app.AerodynamicTorquesPanel.Title = 'Aerodynamic Torques';
            app.AerodynamicTorquesPanel.FontSize = 16;
            app.AerodynamicTorquesPanel.Position = [134 116 392 467];

            % Create GridLayout4_12
            app.GridLayout4_12 = uigridlayout(app.AerodynamicTorquesPanel);
            app.GridLayout4_12.ColumnWidth = {'1x'};
            app.GridLayout4_12.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_12.Padding = [20 10 20 10];

            % Create AeroTorqueX
            app.AeroTorqueX = uiaxes(app.GridLayout4_12);
            title(app.AeroTorqueX, '')
            xlabel(app.AeroTorqueX, '')
            ylabel(app.AeroTorqueX, 'T_x (Nm)')
            app.AeroTorqueX.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.AeroTorqueX.Layout.Row = 1;
            app.AeroTorqueX.Layout.Column = 1;

            % Create AeroTorqueY
            app.AeroTorqueY = uiaxes(app.GridLayout4_12);
            title(app.AeroTorqueY, '')
            xlabel(app.AeroTorqueY, '')
            ylabel(app.AeroTorqueY, 'T_y (Nm)')
            app.AeroTorqueY.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.AeroTorqueY.Layout.Row = 2;
            app.AeroTorqueY.Layout.Column = 1;

            % Create AeroTorqueZ
            app.AeroTorqueZ = uiaxes(app.GridLayout4_12);
            title(app.AeroTorqueZ, '')
            xlabel(app.AeroTorqueZ, 'Orbits')
            ylabel(app.AeroTorqueZ, 'T_z (Nm)')
            app.AeroTorqueZ.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.AeroTorqueZ.Layout.Row = 3;
            app.AeroTorqueZ.Layout.Column = 1;

            % Create OpticalTorquesPanel
            app.OpticalTorquesPanel = uipanel(app.Torques2Tab);
            app.OpticalTorquesPanel.Title = 'Optical Torques';
            app.OpticalTorquesPanel.FontSize = 16;
            app.OpticalTorquesPanel.Position = [623 116 392 467];

            % Create GridLayout4_13
            app.GridLayout4_13 = uigridlayout(app.OpticalTorquesPanel);
            app.GridLayout4_13.ColumnWidth = {'1x'};
            app.GridLayout4_13.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_13.Padding = [20 10 20 10];

            % Create OptTorqueX
            app.OptTorqueX = uiaxes(app.GridLayout4_13);
            title(app.OptTorqueX, '')
            xlabel(app.OptTorqueX, '')
            ylabel(app.OptTorqueX, 'T_x (Nm)')
            app.OptTorqueX.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.OptTorqueX.Layout.Row = 1;
            app.OptTorqueX.Layout.Column = 1;

            % Create OptTorqueY
            app.OptTorqueY = uiaxes(app.GridLayout4_13);
            title(app.OptTorqueY, '')
            xlabel(app.OptTorqueY, '')
            ylabel(app.OptTorqueY, 'T_y (Nm)')
            app.OptTorqueY.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.OptTorqueY.Layout.Row = 2;
            app.OptTorqueY.Layout.Column = 1;

            % Create OptTorqueZ
            app.OptTorqueZ = uiaxes(app.GridLayout4_13);
            title(app.OptTorqueZ, '')
            xlabel(app.OptTorqueZ, 'Orbits')
            ylabel(app.OptTorqueZ, 'T_z (Nm)')
            app.OptTorqueZ.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.OptTorqueZ.Layout.Row = 3;
            app.OptTorqueZ.Layout.Column = 1;

            % Create MagneticFieldTab
            app.MagneticFieldTab = uitab(app.TabGroup3);
            app.MagneticFieldTab.Title = 'Magnetic Field';

            % Create MagneticFieldBodyFramePanel
            app.MagneticFieldBodyFramePanel = uipanel(app.MagneticFieldTab);
            app.MagneticFieldBodyFramePanel.Title = 'Magnetic Field (Body Frame)';
            app.MagneticFieldBodyFramePanel.FontSize = 16;
            app.MagneticFieldBodyFramePanel.Position = [145 122 392 467];

            % Create GridLayout4_10
            app.GridLayout4_10 = uigridlayout(app.MagneticFieldBodyFramePanel);
            app.GridLayout4_10.ColumnWidth = {'1x'};
            app.GridLayout4_10.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_10.Padding = [20 10 20 10];

            % Create Bx_body
            app.Bx_body = uiaxes(app.GridLayout4_10);
            title(app.Bx_body, '')
            xlabel(app.Bx_body, '')
            ylabel(app.Bx_body, 'B_x (T)')
            app.Bx_body.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Bx_body.Layout.Row = 1;
            app.Bx_body.Layout.Column = 1;

            % Create By_body
            app.By_body = uiaxes(app.GridLayout4_10);
            title(app.By_body, '')
            xlabel(app.By_body, '')
            ylabel(app.By_body, 'B_y (T)')
            app.By_body.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.By_body.Layout.Row = 2;
            app.By_body.Layout.Column = 1;

            % Create Bz_body
            app.Bz_body = uiaxes(app.GridLayout4_10);
            title(app.Bz_body, '')
            xlabel(app.Bz_body, 'Orbits')
            ylabel(app.Bz_body, 'B_z (T)')
            app.Bz_body.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Bz_body.Layout.Row = 3;
            app.Bz_body.Layout.Column = 1;

            % Create MagneticFieldLVLHPanel
            app.MagneticFieldLVLHPanel = uipanel(app.MagneticFieldTab);
            app.MagneticFieldLVLHPanel.Title = 'Magnetic Field (LVLH)';
            app.MagneticFieldLVLHPanel.FontSize = 16;
            app.MagneticFieldLVLHPanel.Position = [650 122 392 467];

            % Create GridLayout4_11
            app.GridLayout4_11 = uigridlayout(app.MagneticFieldLVLHPanel);
            app.GridLayout4_11.ColumnWidth = {'1x'};
            app.GridLayout4_11.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_11.Padding = [20 10 20 10];

            % Create Bx_LVLH
            app.Bx_LVLH = uiaxes(app.GridLayout4_11);
            title(app.Bx_LVLH, '')
            xlabel(app.Bx_LVLH, '')
            ylabel(app.Bx_LVLH, 'B_x (T)')
            app.Bx_LVLH.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Bx_LVLH.Layout.Row = 1;
            app.Bx_LVLH.Layout.Column = 1;

            % Create By_LVLH
            app.By_LVLH = uiaxes(app.GridLayout4_11);
            title(app.By_LVLH, '')
            xlabel(app.By_LVLH, '')
            ylabel(app.By_LVLH, 'B_y (T)')
            app.By_LVLH.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.By_LVLH.Layout.Row = 2;
            app.By_LVLH.Layout.Column = 1;

            % Create Bz_LVLH
            app.Bz_LVLH = uiaxes(app.GridLayout4_11);
            title(app.Bz_LVLH, '')
            xlabel(app.Bz_LVLH, 'Orbits')
            ylabel(app.Bz_LVLH, 'B_z (T)')
            app.Bz_LVLH.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Bz_LVLH.Layout.Row = 3;
            app.Bz_LVLH.Layout.Column = 1;

            % Create AttitudeInformationTab
            app.AttitudeInformationTab = uitab(app.TabGroup);
            app.AttitudeInformationTab.Title = 'Attitude Information';

            % Create TabGroup2
            app.TabGroup2 = uitabgroup(app.AttitudeInformationTab);
            app.TabGroup2.Position = [1 1 1198 674];

            % Create DetumbleTab
            app.DetumbleTab = uitab(app.TabGroup2);
            app.DetumbleTab.Title = 'Detumble';

            % Create TimeuntilattitudedetumbleorbitsEditFieldLabel
            app.TimeuntilattitudedetumbleorbitsEditFieldLabel = uilabel(app.DetumbleTab);
            app.TimeuntilattitudedetumbleorbitsEditFieldLabel.HorizontalAlignment = 'right';
            app.TimeuntilattitudedetumbleorbitsEditFieldLabel.Position = [42 541 200 22];
            app.TimeuntilattitudedetumbleorbitsEditFieldLabel.Text = 'Time until attitude detumble (orbits):';

            % Create TimeuntilattitudedetumbleorbitsEditField
            app.TimeuntilattitudedetumbleorbitsEditField = uieditfield(app.DetumbleTab, 'text');
            app.TimeuntilattitudedetumbleorbitsEditField.Editable = 'off';
            app.TimeuntilattitudedetumbleorbitsEditField.Position = [257 541 100 22];

            % Create TimeuntilattitudedetumbledaysEditFieldLabel
            app.TimeuntilattitudedetumbledaysEditFieldLabel = uilabel(app.DetumbleTab);
            app.TimeuntilattitudedetumbledaysEditFieldLabel.HorizontalAlignment = 'right';
            app.TimeuntilattitudedetumbledaysEditFieldLabel.Position = [47 510 195 22];
            app.TimeuntilattitudedetumbledaysEditFieldLabel.Text = 'Time until attitude detumble (days):';

            % Create TimeuntilattitudedetumbledaysEditField
            app.TimeuntilattitudedetumbledaysEditField = uieditfield(app.DetumbleTab, 'text');
            app.TimeuntilattitudedetumbledaysEditField.Editable = 'off';
            app.TimeuntilattitudedetumbledaysEditField.Position = [257 510 100 22];

            % Create BodyAngularRatesPanel_Detumble
            app.BodyAngularRatesPanel_Detumble = uipanel(app.DetumbleTab);
            app.BodyAngularRatesPanel_Detumble.Title = 'Body Angular Rates';
            app.BodyAngularRatesPanel_Detumble.FontSize = 16;
            app.BodyAngularRatesPanel_Detumble.Position = [466 25 667 602];

            % Create GridLayout4_6
            app.GridLayout4_6 = uigridlayout(app.BodyAngularRatesPanel_Detumble);
            app.GridLayout4_6.ColumnWidth = {'1x'};
            app.GridLayout4_6.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_6.Padding = [20 10 20 10];

            % Create roll_rate_detumble
            app.roll_rate_detumble = uiaxes(app.GridLayout4_6);
            title(app.roll_rate_detumble, '')
            xlabel(app.roll_rate_detumble, '')
            ylabel(app.roll_rate_detumble, '\omega_x (\circ/s)')
            app.roll_rate_detumble.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.roll_rate_detumble.Layout.Row = 1;
            app.roll_rate_detumble.Layout.Column = 1;

            % Create pitch_rate_detumble
            app.pitch_rate_detumble = uiaxes(app.GridLayout4_6);
            title(app.pitch_rate_detumble, '')
            xlabel(app.pitch_rate_detumble, '')
            ylabel(app.pitch_rate_detumble, '\omega_y (\circ/s)')
            app.pitch_rate_detumble.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.pitch_rate_detumble.Layout.Row = 2;
            app.pitch_rate_detumble.Layout.Column = 1;

            % Create yaw_rate_detumble
            app.yaw_rate_detumble = uiaxes(app.GridLayout4_6);
            title(app.yaw_rate_detumble, '')
            xlabel(app.yaw_rate_detumble, 'Orbits')
            ylabel(app.yaw_rate_detumble, '\omega_z (\circ/s)')
            app.yaw_rate_detumble.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.yaw_rate_detumble.Layout.Row = 3;
            app.yaw_rate_detumble.Layout.Column = 1;

            % Create HystAxes
            app.HystAxes = uiaxes(app.DetumbleTab);
            title(app.HystAxes, 'Hysteresis Loop Sample')
            xlabel(app.HystAxes, 'H (A/m)')
            ylabel(app.HystAxes, 'B (T)')
            app.HystAxes.PlotBoxAspectRatio = [1.4602510460251 1 1];
            app.HystAxes.Position = [40 179 397 294];

            % Create TimeuntilradiodetumbleorbitsEditFieldLabel
            app.TimeuntilradiodetumbleorbitsEditFieldLabel = uilabel(app.DetumbleTab);
            app.TimeuntilradiodetumbleorbitsEditFieldLabel.HorizontalAlignment = 'right';
            app.TimeuntilradiodetumbleorbitsEditFieldLabel.Position = [57 605 185 22];
            app.TimeuntilradiodetumbleorbitsEditFieldLabel.Text = 'Time until radio detumble (orbits):';

            % Create TimeuntilradiodetumbleorbitsEditField
            app.TimeuntilradiodetumbleorbitsEditField = uieditfield(app.DetumbleTab, 'text');
            app.TimeuntilradiodetumbleorbitsEditField.Editable = 'off';
            app.TimeuntilradiodetumbleorbitsEditField.Position = [257 605 100 22];

            % Create TimeuntilradiodetumbledaysEditFieldLabel
            app.TimeuntilradiodetumbledaysEditFieldLabel = uilabel(app.DetumbleTab);
            app.TimeuntilradiodetumbledaysEditFieldLabel.HorizontalAlignment = 'right';
            app.TimeuntilradiodetumbledaysEditFieldLabel.Position = [62 574 180 22];
            app.TimeuntilradiodetumbledaysEditFieldLabel.Text = 'Time until radio detumble (days):';

            % Create TimeuntilradiodetumbledaysEditField
            app.TimeuntilradiodetumbledaysEditField = uieditfield(app.DetumbleTab, 'text');
            app.TimeuntilradiodetumbledaysEditField.Editable = 'off';
            app.TimeuntilradiodetumbledaysEditField.Position = [257 572 100 22];

            % Create EulerAnglesTab
            app.EulerAnglesTab = uitab(app.TabGroup2);
            app.EulerAnglesTab.Title = 'Euler Angles';

            % Create EulerAnglesRollPitchYawPanel
            app.EulerAnglesRollPitchYawPanel = uipanel(app.EulerAnglesTab);
            app.EulerAnglesRollPitchYawPanel.Title = 'Euler Angles (Roll, Pitch, Yaw)';
            app.EulerAnglesRollPitchYawPanel.FontSize = 16;
            app.EulerAnglesRollPitchYawPanel.Position = [13 70 392 467];

            % Create GridLayout4
            app.GridLayout4 = uigridlayout(app.EulerAnglesRollPitchYawPanel);
            app.GridLayout4.ColumnWidth = {'1x'};
            app.GridLayout4.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4.Padding = [20 10 20 10];

            % Create Roll
            app.Roll = uiaxes(app.GridLayout4);
            title(app.Roll, '')
            xlabel(app.Roll, '')
            ylabel(app.Roll, 'Roll (\circ)')
            app.Roll.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Roll.Layout.Row = 1;
            app.Roll.Layout.Column = 1;

            % Create Pitch
            app.Pitch = uiaxes(app.GridLayout4);
            title(app.Pitch, '')
            xlabel(app.Pitch, '')
            ylabel(app.Pitch, 'Pitch (\circ)')
            app.Pitch.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Pitch.Layout.Row = 2;
            app.Pitch.Layout.Column = 1;

            % Create Yaw
            app.Yaw = uiaxes(app.GridLayout4);
            title(app.Yaw, '')
            xlabel(app.Yaw, 'Orbits')
            ylabel(app.Yaw, 'Yaw (\circ)')
            app.Yaw.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Yaw.Layout.Row = 3;
            app.Yaw.Layout.Column = 1;

            % Create BodyAngularRatesPanel
            app.BodyAngularRatesPanel = uipanel(app.EulerAnglesTab);
            app.BodyAngularRatesPanel.Title = 'Body Angular Rates';
            app.BodyAngularRatesPanel.FontSize = 16;
            app.BodyAngularRatesPanel.Position = [403 70 391 467];

            % Create GridLayout4_2
            app.GridLayout4_2 = uigridlayout(app.BodyAngularRatesPanel);
            app.GridLayout4_2.ColumnWidth = {'1x'};
            app.GridLayout4_2.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_2.Padding = [20 10 20 10];

            % Create roll_rate
            app.roll_rate = uiaxes(app.GridLayout4_2);
            title(app.roll_rate, '')
            xlabel(app.roll_rate, '')
            ylabel(app.roll_rate, '\omega_x (\circ/s)')
            app.roll_rate.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.roll_rate.Layout.Row = 1;
            app.roll_rate.Layout.Column = 1;

            % Create pitch_rate
            app.pitch_rate = uiaxes(app.GridLayout4_2);
            title(app.pitch_rate, '')
            xlabel(app.pitch_rate, '')
            ylabel(app.pitch_rate, '\omega_y (\circ/s)')
            app.pitch_rate.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.pitch_rate.Layout.Row = 2;
            app.pitch_rate.Layout.Column = 1;

            % Create yaw_rate
            app.yaw_rate = uiaxes(app.GridLayout4_2);
            title(app.yaw_rate, '')
            xlabel(app.yaw_rate, 'Orbits')
            ylabel(app.yaw_rate, '\omega_z (\circ/s)')
            app.yaw_rate.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.yaw_rate.Layout.Row = 3;
            app.yaw_rate.Layout.Column = 1;

            % Create BodyAngularAccelerationsPanel
            app.BodyAngularAccelerationsPanel = uipanel(app.EulerAnglesTab);
            app.BodyAngularAccelerationsPanel.Title = 'Body Angular Accelerations';
            app.BodyAngularAccelerationsPanel.FontSize = 16;
            app.BodyAngularAccelerationsPanel.Position = [793 70 391 467];

            % Create GridLayout4_3
            app.GridLayout4_3 = uigridlayout(app.BodyAngularAccelerationsPanel);
            app.GridLayout4_3.ColumnWidth = {'1x'};
            app.GridLayout4_3.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_3.Padding = [20 10 20 10];

            % Create roll_acc
            app.roll_acc = uiaxes(app.GridLayout4_3);
            title(app.roll_acc, '')
            xlabel(app.roll_acc, '')
            ylabel(app.roll_acc, '\alpha_x (\circ/s^2)')
            app.roll_acc.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.roll_acc.Layout.Row = 1;
            app.roll_acc.Layout.Column = 1;

            % Create pitch_acc
            app.pitch_acc = uiaxes(app.GridLayout4_3);
            title(app.pitch_acc, '')
            xlabel(app.pitch_acc, '')
            ylabel(app.pitch_acc, '\alpha_y (\circ/s^2)')
            app.pitch_acc.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.pitch_acc.Layout.Row = 2;
            app.pitch_acc.Layout.Column = 1;

            % Create yaw_acc
            app.yaw_acc = uiaxes(app.GridLayout4_3);
            title(app.yaw_acc, '')
            xlabel(app.yaw_acc, 'Orbits')
            ylabel(app.yaw_acc, '\alpha_z (\circ/s^2)')
            app.yaw_acc.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.yaw_acc.Layout.Row = 3;
            app.yaw_acc.Layout.Column = 1;

            % Create PostDetumbleAttitudeInformationLabel
            app.PostDetumbleAttitudeInformationLabel = uilabel(app.EulerAnglesTab);
            app.PostDetumbleAttitudeInformationLabel.FontSize = 20;
            app.PostDetumbleAttitudeInformationLabel.Position = [66 598 328 26];
            app.PostDetumbleAttitudeInformationLabel.Text = 'Post-Detumble Attitude Information';

            % Create DisplayAttitudeAnimationButton
            app.DisplayAttitudeAnimationButton = uibutton(app.EulerAnglesTab, 'push');
            app.DisplayAttitudeAnimationButton.ButtonPushedFcn = createCallbackFcn(app, @DisplayAttitudeAnimationButtonPushed, true);
            app.DisplayAttitudeAnimationButton.BackgroundColor = [0.4667 0.6745 0.1882];
            app.DisplayAttitudeAnimationButton.FontSize = 16;
            app.DisplayAttitudeAnimationButton.FontWeight = 'bold';
            app.DisplayAttitudeAnimationButton.Position = [532 587 219 49];
            app.DisplayAttitudeAnimationButton.Text = 'Display Attitude Animation';

            % Create Speedfactor0to100EditFieldLabel
            app.Speedfactor0to100EditFieldLabel = uilabel(app.EulerAnglesTab);
            app.Speedfactor0to100EditFieldLabel.HorizontalAlignment = 'right';
            app.Speedfactor0to100EditFieldLabel.Position = [545 556 132 22];
            app.Speedfactor0to100EditFieldLabel.Text = 'Speed factor (0 to 100):';

            % Create Speedfactor0to100EditField
            app.Speedfactor0to100EditField = uieditfield(app.EulerAnglesTab, 'numeric');
            app.Speedfactor0to100EditField.Limits = [0 100];
            app.Speedfactor0to100EditField.ValueChangedFcn = createCallbackFcn(app, @Speedfactor0to100EditFieldValueChanged, true);
            app.Speedfactor0to100EditField.Position = [692 556 47 22];
            app.Speedfactor0to100EditField.Value = 100;

            % Create PointingTab
            app.PointingTab = uitab(app.TabGroup2);
            app.PointingTab.Title = 'Pointing';

            % Create NadirAxes
            app.NadirAxes = uiaxes(app.PointingTab);
            title(app.NadirAxes, 'Deviation of CubeSat Z-Axis from Nadir')
            xlabel(app.NadirAxes, 'Orbits')
            ylabel(app.NadirAxes, 'Deviation (\circ)')
            app.NadirAxes.PlotBoxAspectRatio = [2.06113537117904 1 1];
            app.NadirAxes.Position = [29 255 521 284];

            % Create NorthAxes
            app.NorthAxes = uiaxes(app.PointingTab);
            title(app.NorthAxes, 'Deviation of CubeSat X-Axis from Magnetic North')
            xlabel(app.NorthAxes, 'Orbits')
            ylabel(app.NorthAxes, 'Deviation (\circ)')
            app.NorthAxes.PlotBoxAspectRatio = [2.06113537117904 1 1];
            app.NorthAxes.Position = [599 255 521 284];

            % Create OrbitalperiodminEditFieldLabel
            app.OrbitalperiodminEditFieldLabel = uilabel(app.PointingTab);
            app.OrbitalperiodminEditFieldLabel.HorizontalAlignment = 'right';
            app.OrbitalperiodminEditFieldLabel.Position = [213 199 111 22];
            app.OrbitalperiodminEditFieldLabel.Text = 'Orbital period (min):';

            % Create Orbitalperiod
            app.Orbitalperiod = uieditfield(app.PointingTab, 'text');
            app.Orbitalperiod.Editable = 'off';
            app.Orbitalperiod.Position = [339 199 100 22];

            % Create MaximumdeviationafterdetumbledegLabel
            app.MaximumdeviationafterdetumbledegLabel = uilabel(app.PointingTab);
            app.MaximumdeviationafterdetumbledegLabel.HorizontalAlignment = 'right';
            app.MaximumdeviationafterdetumbledegLabel.Position = [97 163 227 22];
            app.MaximumdeviationafterdetumbledegLabel.Text = 'Maximum deviation after detumble (deg):';

            % Create NadirDevMax
            app.NadirDevMax = uieditfield(app.PointingTab, 'text');
            app.NadirDevMax.Editable = 'off';
            app.NadirDevMax.Position = [339 163 100 22];

            % Create PercentofpostsettlingtimemeetingrequirementEditFieldLabel
            app.PercentofpostsettlingtimemeetingrequirementEditFieldLabel = uilabel(app.PointingTab);
            app.PercentofpostsettlingtimemeetingrequirementEditFieldLabel.HorizontalAlignment = 'right';
            app.PercentofpostsettlingtimemeetingrequirementEditFieldLabel.Position = [46 127 278 22];
            app.PercentofpostsettlingtimemeetingrequirementEditFieldLabel.Text = 'Percent of post-settling time meeting requirement:';

            % Create NadirPctMet
            app.NadirPctMet = uieditfield(app.PointingTab, 'text');
            app.NadirPctMet.Editable = 'off';
            app.NadirPctMet.Position = [339 127 100 22];

            % Create MaximumdeviationafterdetumbledegLabel_2
            app.MaximumdeviationafterdetumbledegLabel_2 = uilabel(app.PointingTab);
            app.MaximumdeviationafterdetumbledegLabel_2.HorizontalAlignment = 'right';
            app.MaximumdeviationafterdetumbledegLabel_2.Position = [710 199 227 22];
            app.MaximumdeviationafterdetumbledegLabel_2.Text = 'Maximum deviation after detumble (deg):';

            % Create NorthDevMax
            app.NorthDevMax = uieditfield(app.PointingTab, 'text');
            app.NorthDevMax.Editable = 'off';
            app.NorthDevMax.Position = [952 199 100 22];

            % Create PercentofpostdetumbletimemeetingrequirementLabel
            app.PercentofpostdetumbletimemeetingrequirementLabel = uilabel(app.PointingTab);
            app.PercentofpostdetumbletimemeetingrequirementLabel.HorizontalAlignment = 'right';
            app.PercentofpostdetumbletimemeetingrequirementLabel.Position = [647 163 290 22];
            app.PercentofpostdetumbletimemeetingrequirementLabel.Text = 'Percent of post-detumble time meeting requirement:';

            % Create NorthPctMet
            app.NorthPctMet = uieditfield(app.PointingTab, 'text');
            app.NorthPctMet.Editable = 'off';
            app.NorthPctMet.Position = [952 163 100 22];

            % Create LatitudebelowwhichpointingrequirementpercentageismetdegLabel
            app.LatitudebelowwhichpointingrequirementpercentageismetdegLabel = uilabel(app.PointingTab);
            app.LatitudebelowwhichpointingrequirementpercentageismetdegLabel.HorizontalAlignment = 'right';
            app.LatitudebelowwhichpointingrequirementpercentageismetdegLabel.Visible = 'off';
            app.LatitudebelowwhichpointingrequirementpercentageismetdegLabel.Position = [565 127 372 22];
            app.LatitudebelowwhichpointingrequirementpercentageismetdegLabel.Text = 'Latitude below which pointing requirement percentage is met (deg):';

            % Create NorthLatIgnore
            app.NorthLatIgnore = uieditfield(app.PointingTab, 'text');
            app.NorthLatIgnore.Editable = 'off';
            app.NorthLatIgnore.Visible = 'off';
            app.NorthLatIgnore.Position = [952 127 100 22];

            % Create PostDetumblePointingInformationLabel
            app.PostDetumblePointingInformationLabel = uilabel(app.PointingTab);
            app.PostDetumblePointingInformationLabel.FontSize = 20;
            app.PostDetumblePointingInformationLabel.Position = [66 598 331 26];
            app.PostDetumblePointingInformationLabel.Text = 'Post-Detumble Pointing Information';

            % Create BoomdeploymenttimeorbitsEditFieldLabel
            app.BoomdeploymenttimeorbitsEditFieldLabel = uilabel(app.PointingTab);
            app.BoomdeploymenttimeorbitsEditFieldLabel.HorizontalAlignment = 'right';
            app.BoomdeploymenttimeorbitsEditFieldLabel.Position = [446 591 174 22];
            app.BoomdeploymenttimeorbitsEditFieldLabel.Text = 'Boom deployment time (orbits):';

            % Create BoomdeploymenttimeorbitsEditField
            app.BoomdeploymenttimeorbitsEditField = uieditfield(app.PointingTab, 'text');
            app.BoomdeploymenttimeorbitsEditField.Editable = 'off';
            app.BoomdeploymenttimeorbitsEditField.Position = [635 591 53 22];

            % Create MiscTab
            app.MiscTab = uitab(app.TabGroup2);
            app.MiscTab.Title = 'Misc';

            % Create FourierTransformsofRollPitchandYawRatesPanel
            app.FourierTransformsofRollPitchandYawRatesPanel = uipanel(app.MiscTab);
            app.FourierTransformsofRollPitchandYawRatesPanel.Title = 'Fourier Transforms of Roll, Pitch, and Yaw Rates';
            app.FourierTransformsofRollPitchandYawRatesPanel.FontSize = 16;
            app.FourierTransformsofRollPitchandYawRatesPanel.Position = [247 104 392 467];

            % Create GridLayout4_14
            app.GridLayout4_14 = uigridlayout(app.FourierTransformsofRollPitchandYawRatesPanel);
            app.GridLayout4_14.ColumnWidth = {'1x'};
            app.GridLayout4_14.RowHeight = {'8x', '8x', '8x'};
            app.GridLayout4_14.Padding = [20 10 20 10];

            % Create Roll_F
            app.Roll_F = uiaxes(app.GridLayout4_14);
            title(app.Roll_F, '')
            xlabel(app.Roll_F, '')
            ylabel(app.Roll_F, 'Roll Amplitude (\circ/s)')
            app.Roll_F.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Roll_F.Layout.Row = 1;
            app.Roll_F.Layout.Column = 1;

            % Create Pitch_F
            app.Pitch_F = uiaxes(app.GridLayout4_14);
            title(app.Pitch_F, '')
            xlabel(app.Pitch_F, '')
            ylabel(app.Pitch_F, 'Pitch Amplitude (\circ/s)')
            app.Pitch_F.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Pitch_F.Layout.Row = 2;
            app.Pitch_F.Layout.Column = 1;

            % Create Yaw_F
            app.Yaw_F = uiaxes(app.GridLayout4_14);
            title(app.Yaw_F, '')
            xlabel(app.Yaw_F, 'Frequency (Hz)')
            ylabel(app.Yaw_F, 'Yaw Amplitude (\circ/s)')
            app.Yaw_F.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Yaw_F.Layout.Row = 3;
            app.Yaw_F.Layout.Column = 1;

            % Create AttitudeDeterminationTab
            app.AttitudeDeterminationTab = uitab(app.TabGroup);
            app.AttitudeDeterminationTab.Title = 'Attitude Determination';

            % Create IntegratedEulerAnglesbasedonIMUdataPanel
            app.IntegratedEulerAnglesbasedonIMUdataPanel = uipanel(app.AttitudeDeterminationTab);
            app.IntegratedEulerAnglesbasedonIMUdataPanel.Title = 'Integrated Euler Angles based on IMU data';
            app.IntegratedEulerAnglesbasedonIMUdataPanel.FontSize = 16;
            app.IntegratedEulerAnglesbasedonIMUdataPanel.Position = [83 276 396 391];

            % Create GridLayout4_4
            app.GridLayout4_4 = uigridlayout(app.IntegratedEulerAnglesbasedonIMUdataPanel);
            app.GridLayout4_4.ColumnWidth = {'1x'};
            app.GridLayout4_4.RowHeight = {'8x', '8x', '10x'};
            app.GridLayout4_4.Padding = [20 10 20 10];

            % Create Roll_IMU
            app.Roll_IMU = uiaxes(app.GridLayout4_4);
            title(app.Roll_IMU, '')
            xlabel(app.Roll_IMU, '')
            ylabel(app.Roll_IMU, 'Roll')
            app.Roll_IMU.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Roll_IMU.Layout.Row = 1;
            app.Roll_IMU.Layout.Column = 1;

            % Create Pitch_IMU
            app.Pitch_IMU = uiaxes(app.GridLayout4_4);
            title(app.Pitch_IMU, '')
            xlabel(app.Pitch_IMU, '')
            ylabel(app.Pitch_IMU, 'Pitch')
            app.Pitch_IMU.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Pitch_IMU.XTick = [0 0.5 1];
            app.Pitch_IMU.Layout.Row = 2;
            app.Pitch_IMU.Layout.Column = 1;

            % Create Yaw_IMU
            app.Yaw_IMU = uiaxes(app.GridLayout4_4);
            title(app.Yaw_IMU, '')
            xlabel(app.Yaw_IMU, 'Orbits')
            ylabel(app.Yaw_IMU, 'Yaw')
            app.Yaw_IMU.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.Yaw_IMU.Layout.Row = 3;
            app.Yaw_IMU.Layout.Column = 1;

            % Create MinimumIMUsampleperiodforsmallerrorsecEditFieldLabel
            app.MinimumIMUsampleperiodforsmallerrorsecEditFieldLabel = uilabel(app.AttitudeDeterminationTab);
            app.MinimumIMUsampleperiodforsmallerrorsecEditFieldLabel.HorizontalAlignment = 'right';
            app.MinimumIMUsampleperiodforsmallerrorsecEditFieldLabel.Visible = 'off';
            app.MinimumIMUsampleperiodforsmallerrorsecEditFieldLabel.Position = [35 23 273 22];
            app.MinimumIMUsampleperiodforsmallerrorsecEditFieldLabel.Text = 'Minimum IMU sample period for small error (sec):';

            % Create MinIMURate
            app.MinIMURate = uieditfield(app.AttitudeDeterminationTab, 'text');
            app.MinIMURate.Editable = 'off';
            app.MinIMURate.Visible = 'off';
            app.MinIMURate.Position = [323 23 100 22];

            % Create NominalangletohorizondegLabel
            app.NominalangletohorizondegLabel = uilabel(app.AttitudeDeterminationTab);
            app.NominalangletohorizondegLabel.HorizontalAlignment = 'right';
            app.NominalangletohorizondegLabel.Position = [727 632 172 22];
            app.NominalangletohorizondegLabel.Text = 'Nominal angle to horizon (deg):';

            % Create HorizonAngle
            app.HorizonAngle = uieditfield(app.AttitudeDeterminationTab, 'text');
            app.HorizonAngle.Editable = 'off';
            app.HorizonAngle.Position = [914 632 100 22];

            % Create ZAxisBoresight
            app.ZAxisBoresight = uiaxes(app.AttitudeDeterminationTab);
            title(app.ZAxisBoresight, 'Earth in Z-Axis Optical Boresight')
            xlabel(app.ZAxisBoresight, 'Orbits')
            ylabel(app.ZAxisBoresight, 'Yes/No')
            app.ZAxisBoresight.PlotBoxAspectRatio = [4.21052631578947 1 1];
            app.ZAxisBoresight.Position = [653 469 448 150];

            % Create AttitudeDeterminationBoresightDataPanel
            app.AttitudeDeterminationBoresightDataPanel = uipanel(app.AttitudeDeterminationTab);
            app.AttitudeDeterminationBoresightDataPanel.Title = 'Attitude Determination Boresight Data';
            app.AttitudeDeterminationBoresightDataPanel.FontSize = 16;
            app.AttitudeDeterminationBoresightDataPanel.Position = [706 13 364 449];

            % Create GridLayout4_5
            app.GridLayout4_5 = uigridlayout(app.AttitudeDeterminationBoresightDataPanel);
            app.GridLayout4_5.ColumnWidth = {'1x'};
            app.GridLayout4_5.RowHeight = {'8x', '8x', '8x', '8x'};
            app.GridLayout4_5.Padding = [20 10 20 10];

            % Create PlusYBoresights
            app.PlusYBoresights = uiaxes(app.GridLayout4_5);
            title(app.PlusYBoresights, '')
            xlabel(app.PlusYBoresights, '')
            ylabel(app.PlusYBoresights, '+Y Face')
            app.PlusYBoresights.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.PlusYBoresights.Layout.Row = 2;
            app.PlusYBoresights.Layout.Column = 1;

            % Create MinusXBoresights
            app.MinusXBoresights = uiaxes(app.GridLayout4_5);
            title(app.MinusXBoresights, '')
            xlabel(app.MinusXBoresights, '')
            ylabel(app.MinusXBoresights, '-X Face')
            app.MinusXBoresights.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.MinusXBoresights.Layout.Row = 3;
            app.MinusXBoresights.Layout.Column = 1;

            % Create PlusXBoresights
            app.PlusXBoresights = uiaxes(app.GridLayout4_5);
            title(app.PlusXBoresights, '')
            xlabel(app.PlusXBoresights, '')
            ylabel(app.PlusXBoresights, '+X Face')
            app.PlusXBoresights.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.PlusXBoresights.Layout.Row = 1;
            app.PlusXBoresights.Layout.Column = 1;

            % Create MinusYBoresights
            app.MinusYBoresights = uiaxes(app.GridLayout4_5);
            title(app.MinusYBoresights, '')
            xlabel(app.MinusYBoresights, '')
            ylabel(app.MinusYBoresights, '-Y Face')
            app.MinusYBoresights.PlotBoxAspectRatio = [4.04040404040404 1 1];
            app.MinusYBoresights.Layout.Row = 4;
            app.MinusYBoresights.Layout.Column = 1;

            % Create Nadir_Reconstruction
            app.Nadir_Reconstruction = uiaxes(app.AttitudeDeterminationTab);
            title(app.Nadir_Reconstruction, 'Nadir pointing deviation from IMU data')
            xlabel(app.Nadir_Reconstruction, 'Orbits')
            ylabel(app.Nadir_Reconstruction, 'Deviation (\circ)')
            app.Nadir_Reconstruction.PlotBoxAspectRatio = [2.68461538461538 1 1];
            app.Nadir_Reconstruction.Position = [104 44 398 185];

            % Show the figure after all components are created
            app.CubeSatADSSDesignandSimulationUIFigure.Visible = 'on';
        end
    end

    % App creation and deletion
    methods (Access = public)

        % Construct app
        function app = CubeSatADSSDesign

            % Create UIFigure and components
            createComponents(app)

            % Register the app with App Designer
            registerApp(app, app.CubeSatADSSDesignandSimulationUIFigure)

            if nargout == 0
                clear app
            end
        end

        % Code that executes before app deletion
        function delete(app)

            % Delete UIFigure when app is deleted
            delete(app.CubeSatADSSDesignandSimulationUIFigure)
        end
    end
end